import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.ProgressMonitor;
import java.net.*;
import java.util.*;
import java.util.GregorianCalendar;
import java.util.Random;

public  class BankServer extends JFrame{

           int LUNG=400;
            int LARG=400;
            JTextArea areaTesto=new JTextArea();
            GestoreBankServer sportello;
            
 public static void main(String args[]){
 
      BankServer server=new BankServer();
      server.run();
      

 }
 
           
 // Costruttore           
  public BankServer() {
    
            super("BANK SERVER");
            setSize(LUNG,LARG);
            buildGUI();
            show();
     }
     
               
   // Costruzione della parte grafica
    void buildGUI() {
         
          getContentPane().setLayout(null);
          areaTesto.setBounds(30,30,280,250);
         
         
          getContentPane().add(areaTesto);
          areaTesto.setBorder(new BevelBorder(BevelBorder.LOWERED));
          
          }  
            
   public void run() {
        
        sportello=new GestoreBankServer();
        try {
                ServerSocket server=new ServerSocket(1236);
                int localport=server.getLocalPort();
                areaTesto.append("\nIn ascolto sulla porta "+localport);
                int i=0;
                do{
                    Socket client=server.accept();
                    i++;
                    (new BankThread(client,areaTesto,sportello)).start();
                }while(true);
            }catch(IOException ex) {System.out.println("Errore");
                     System.exit(0);}
        }
       
   }//Fine classe BankServer      
   
   
   
   
   
   class BankThread extends Thread {
       Socket client;
       BufferedReader inStream;
       DataOutputStream outStream;
       JTextArea areaTesto;
       GestoreBankServer sportello;
       String inLine;
       
       //Costruttore del thread
       public BankThread(Socket client,JTextArea areaTesto,GestoreBankServer sportello) {

         this.client=client;
         this.areaTesto=areaTesto;
         this.sportello=sportello;
    }//Fine costruttore
           
           
  //Inizio vero e proprio del thread         
    public void run(){   
         try{
                String destname=client.getInetAddress().getHostName();
                int destport=client.getPort();
                areaTesto.append("\nConnessione ");
                areaTesto.append("\nAccettata a "+destname+" sulla porta "+destport); 
                
                 inStream=new BufferedReader(new InputStreamReader(client.getInputStream()));
                 outStream=new DataOutputStream(client.getOutputStream());
                 
                 String message=receiveMessage();
                 processRequest(message);      
                
              }catch(IOException ex) {System.out.println("Errore");}  
              
 }
 
 void processRequest(String message){
    
    int d=message.indexOf('.');
    int i=message.indexOf('#');
    int j=message.indexOf('$');
    int k=message.indexOf('@');
    int x=message.indexOf('&');
    int n=message.length();
    
    String numero=message.substring(d+1,i);
    String nome=message.substring(i+1,j);
    String cognome=message.substring(j+1,k);
    String password=message.substring(k+1,x);
    String prezzo=message.substring(x+1,n);
    int p=Integer.parseInt(prezzo);
    int ans=sportello.preleva(numero,nome,cognome,password,p);
    
    if(ans==1) {//conto corrente aggiornato e pagamento effettuato
          areaTesto.append("\nTransazione effettuata");
          int risp=sendMessage("OK");//comunico al server che mi ha interpellato
          if (risp==1) {//se il msg al server  andato
               message=receiveMessage();//e attendo la terminazione del collegamento
               if((message==null)||(message.equalsIgnoreCase("ABT"))){//il server  crashato e ripristino
                    sportello.ripristina(numero,nome,cognome,password,p);
                    areaTesto.append("\nTransazione annullata");
               }
               if(message.equalsIgnoreCase("OK"){
                   message=receiveMessage();//e attendo la terminazione del collegamento
                   if((message==null)||(message.equalsIgnoreCase("ABT"))){//il server  crashato e ripristino
                      sportello.ripristina(numero,nome,cognome,password,p);
                      areaTesto.append("\nTransazione annullata");
                   }
                   if(message.equalsIgnoreCase("TERM"))closeConnection();
              }
               
          }
          else {//il server  crashato e ripristino
               sportello.ripristina(numero,nome,cognome,password,p);
               areaTesto.append("\nTransazione annullata");
               closeConnection();
          }
     }
    if(ans==-1){//non c' disponibilit sul conto
         areaTesto.append("\nTransazione NON effettuata: credito non disponibile");
         int risp=sendMessage("INS");//..lo comunico al server che mi ha interpellato
         closeConnection();
        }
   if(ans==0){//il cc non esiste
          areaTesto.append("\nTransazione NON effettuata: conto inesistente.");
          int risp=sendMessage("NO");//lo comunico al server che mi ha interpellato
          closeConnection();
     }
 
 }//Fine processRequest
   
 /*
--------------------------------------------------------------------------------------------------------------------------------------------------
METODI DI SERVIZIO PER LA RICEZIONE E LA SPEDIZIONE DEI MESSAGGI AL SERVER
E LA CHIUSURA DELLA CONNESSSIONE
*/


//Usata per chiudere la connessione e uccidere il thread in esecuzione
void closeConnection(){
    
    try{
       client.close();
       areaTesto.append("\nChiudo collegamento ");
    }catch(IOException ex) {;}
    this.stop();

}//fine closeConnection()

//Usata per ricevere messaggi       
  String receiveMessage() {     
       
      
            try{
              
              inLine=inStream.readLine();
              

             }catch(IOException ex) {System.out.println("Errore");}   
           
                return inLine;
            }
            
            
//Usata per spedire messaggi            
     int sendMessage(String message) {
     
         try{
       
        for(int i=0;i<message.length();++i) 
           outStream.write(message.charAt(i));
           outStream.write(13);
           outStream.write(10);
           outStream.flush();
           
          }catch (IOException ex) {
                   return 0;}
          return 1; 
     
     
     }
     
/*--------------------------------------------------------------------------------------------------------------------------------------*/    
    
    
 }//Fine BankThread