/*
La classe:
RICEVE
la mappa e il collegamento al Gestore
1. Crea la mappa visuale dei posti
2. Passa il controllo  alla MapMessage passando Gestore, selezione
DA FARE
2. Da dirottare la chiusura della finestra su Finestra1
3. Gestione della concorrenza affidata al gestore tramite la MapMessage
4. Resta in background la finestra durante la conferma???? 
    Attualmente si preferisce chiuderal e poi riaprirla eventualmente con una nuova lettura del DB da server
*/
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;
import java.lang.Object.*;
import java.util.*;
import java.io.LineNumberReader;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.lang.Integer;
import java.lang.System;
import java.util.Vector;
import java.util.Enumeration;
import java.awt.Component;

public class CreazionePosti extends JFrame {

    int LARG=700;
    int LUNG;
    int spaziox=400;
    int spazioy=380;
    String [] posti;
    Vector V=new Vector();
    int postitot;
    int nfile;
    int pos;
    MapMessage win;
   
    JButton select=new JButton("SELECT");
    
    JPanel bottoni=new JPanel();
    JPanel schema=new JPanel();
    
    Font font24=new Font("Palatino",Font.BOLD,24);
    Font font18=new Font("Palatino",Font.BOLD,18);
    Font font16=new Font("Palatino",Font.BOLD,16);
    Font font14=new Font("Palatino",Font.BOLD,14);
    Font font12=new Font("Palatino",Font.BOLD,12);
    
    ButtonGroup gruppo=new ButtonGroup();
    
    Gestore gestore;
 
    
    
    // Costruttore
    
    public CreazionePosti(String map, Gestore mioGest) {
             
             super("SETTORE"); 
             
             try{
             setTitle("SETTORE"+" "+map.charAt(0)); 
             }catch(StringIndexOutOfBoundsException sbe) {mioGest.restart();}
          
             gestore=mioGest;
             schema.setLayout(null);
             getContentPane().add("South",bottoni);
             letturaStringa(map);
             buildGUI(gestore);
             setBackground(Color.black);             
             addWindowListener(new WindowHandler());
             show();
       
      }
    
  //Lettura della stringa x creare la mappa    
        
    void letturaStringa(String map) {   
    
      int n=0;
      int p=1;
      int f=1;
      int lun=map.length();
      for(int i=1;i<lun;++i) {
           if(map.charAt(i)=='-') {
                n++;
                p=1;
                f++;}
           else{
               Place sedia=new Place();
               String modo="";
               sedia.modo= modo+map.charAt(i);
               sedia.posto=(new Integer(p)).toString();
               sedia.fila=(new Integer(f)).toString();
               sedia.bottone=new JToggleButton(sedia.posto,false);
               if ((sedia.modo).equals("E")) (sedia.bottone).setBackground(Color.yellow);
               if((sedia.modo).equals("F"))  {
                               (sedia.bottone).setBackground(Color.red);
                               (sedia.bottone).setText(" ");}
               if((sedia.modo).equals("R"))  {
                               (sedia.bottone).setBackground(Color.lightGray);
                               (sedia.bottone).setText("R");}              
               V.addElement(sedia);
               p++;
             }  
        }
        
      nfile=n;//NUMERO FILE
      postitot=n*10;//NPOSTI
  }
 
 // Crea la mappa grafica dei posti dinamicamente in funzione del numero delle file
   
    void buildGUI(Gestore gestore) {
      
        JPanel campo=new JPanel();
        JLabel erba=new JLabel("TERRENO DI GIOCO");
        JLabel fila=new JLabel("FILA");    
        int dim=V.size();
        
        int x=60;
        int y=30;
        
        int LUNG=30*nfile+160;
        
        setSize(LARG,LUNG);
        
        int xstart=50;
        int ystart=40;
        int xwork=50;
        int ywork=40;
        int n=0;
        int cont=1;
        int fl=1;
   
        for(int i=0;i<dim;++i) {
               Place oggetto=(Place) V.elementAt(i);
               String etic=oggetto.posto;
               String mod=oggetto.modo;
               String f=oggetto.fila;
               schema.add(oggetto.bottone);
               (oggetto.bottone).setBounds(xwork,ywork,x,y);
               (oggetto.bottone).addActionListener(new ButtonHandler(gestore));
               gruppo.add(oggetto.bottone);
               n++;
               if(cont==10) {
                         aggiungiFila(ywork, f);
                         ywork=ywork+y;
                         xwork=xstart;
                         cont=1;
                         }
               else {
                        xwork=xwork+x;
                        cont++;}
             }
           
           fila.setBounds(650,0,50,40);
           campo.setBounds(0,LUNG-80,700,50);
           
           erba.setFont(font24);
           erba.setForeground(Color.black);
           fila.setFont(font18);
           
           campo.add(erba);
           campo.setBackground(Color.green);
           fila.setForeground(Color.white);
                      
           schema.add(campo);
           schema.add(fila);
           schema.setBackground(Color.black);
           setupBottone(gestore);
           getContentPane().add(schema);
    }
   
   
    
  //Aggiunge il nome della fila a cui ci si riferisce  
    void aggiungiFila(int y,String fila) {
        
         JLabel numero=new JLabel(fila);
         numero.setBounds(660,y,50,30);
         numero.setFont(font16);
         numero.setForeground(Color.white);
         schema.add(numero);
    }
   
        
  // settaggio font e colori del bottone principale - aggiunta alla finestra
       
   void setupBottone(Gestore gestore) {
     
      select.setFont(font18);
          
      bottoni.setBackground(Color.black);
      
      select.setForeground(Color.red);
      select.setBackground(Color.black);
       
      select.addActionListener(new ButtonHandler(gestore));
   
      bottoni.add(select);
      
  }  
    
   //Classe che gestisce il bottone di selezione
class ButtonHandler implements ActionListener {
      
      String message;
      int index;
      Gestore gestore;
      
      ButtonHandler(Gestore mioGest) {
           gestore=mioGest;
           }

      public void actionPerformed(ActionEvent e) {   
      
      String etichetta=e.getActionCommand();
      if (etichetta.equalsIgnoreCase("SELECT"))  {
          int dim=V.size();
          for(int i=0;i<dim;++i) {
             Place oggetto=(Place) V.elementAt(i);
             if((oggetto.bottone).isSelected()) {
                      if((oggetto.modo).equals("E")) {
                             message="Hai scelto il posto "+oggetto.posto+" Fila "+oggetto.fila;
                             index=i;
                           }
                      else index=-1;
                 }
             }
            if(index!=-1){
            Place scelta=(Place) V.elementAt(index);
            String selezione= scelta.fila+"-"+scelta.posto;
            win=new MapMessage(message,selezione,gestore,CreazionePosti.this);
           
            }
        }
          
   }       
 }         
          
       
   
class MapHandler implements ActionListener {
      public void actionPerformed(ActionEvent e) {   
         String etichetta=e.getActionCommand();
         
      }
    }
    
    
     // Classe che gestisce la chiusura della finestra - 
 class WindowHandler extends WindowAdapter {
   public void windowClosing(WindowEvent e) {
      
     }
   }
     
  
       
    }
    