/*La classe:
1. Visualizza la finestra di immissione della password
2. Passa user e pwd a Initialize 
*/

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;



public class MainWindow extends JFrame{
 
  public static int LUNG=340;
  public static int LARG=100;
  
  //Componenti
  
  Font font18= new Font("Palatino",Font.BOLD,18);
  Font font14= new Font("Palatino",Font.BOLD,14);
  Font font16= new Font("Palatino",Font.BOLD,16);    
  
  JTextField utente=new JTextField();
  JPasswordField pass= new JPasswordField();
  
  JLabel nome=new JLabel("USER");
  JLabel parola=new JLabel("PASSWORD");

  JButton bottone=new JButton("ENTRA");
  
 //Costruttore 
  
  public MainWindow() {
  
  super("Inserisci User e Password");
  getContentPane().setLayout(null);
  addWindowListener(new WindowHandler());
  buildGUI(); 
  setSize(LUNG,LARG);
  setLocation(200,200);
  setForeground(Color.red);
  show();
  
  }
  
  //Costruisce la parte grafica della finestra 
  void buildGUI() {
     nome.setBounds(10,15,80,25);
     utente.setBounds(150,10,170,25);
     parola.setBounds(10,45,120,25);
     pass.setBounds(150,40,170,25);
     bottone.setBounds(150,70,120,25);
     
     bottone.setFont(font16);
     nome.setFont(font16);
     utente.setFont(font16);
     parola.setFont(font16);
     pass.setFont(font16);
     
     nome.setForeground(Color.black);
     parola.setForeground(Color.red);
     bottone.setForeground(Color.red);
     
     bottone.addActionListener(new AccessHandler());
     
     getContentPane().add(nome);
     getContentPane().add(utente);
     getContentPane().add(parola);
     getContentPane().add(pass);
     getContentPane().add(bottone);
     
      }
     
     
 public static void main(String args[]){
     MainWindow app=new MainWindow();
   }
   
     
      // Classe che gestisce la chiusura della finestra    
 class WindowHandler extends WindowAdapter {
   public void windowClosing(WindowEvent e) {
      System.exit(0);
     }
   }
  
  
  // Classe che gestisce il rilevamento di user e pwd
  class AccessHandler implements ActionListener{
       public void actionPerformed(ActionEvent e) {
          String user=utente.getText();
          String pwd=pass.getText();
          dispose();
          Initialize win=new Initialize(user,pwd); 
         
         }
     }
           
   
}
