/*
LA classe
RICEVE la selezione e il Gestore
1. Crea una finestra di conferma della selezione 
2. Chiama il metodo verificaPosto(String) del Gestore

*/
 import java.awt.*;
 import java.awt.event.*; 
 import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.io.*;
import java.net.Socket;



//Classe per la gestione della finestra di dialogo
public class MapMessage extends Frame  {
    Font font16=new Font("Palatino",Font.BOLD,16);
    Font font14=new Font("Palatino",Font.BOLD,14);
    Font font12=new Font("Palatino",Font.BOLD,12);
    JPanel testo=new JPanel();
    JPanel bottoni=new JPanel();
    Label etic;
    JButton ok=new JButton("OK");
    JButton cancel=new JButton("CANCEL");
    Socket connection;
    DataOutputStream outStream;
    BufferedReader inStream;
 
 public MapMessage (String message,String selezione,Gestore gestore, CreazionePosti parent){
       super("System Message");
       
       etic=new Label(message);  
       etic.setFont(font14);
       etic.setBackground(Color.black);
       etic.setForeground(Color.yellow);
       
       testo.setBackground(Color.black);
       testo.setForeground(Color.yellow);
       testo.add(etic);
       
       ok.setBackground(Color.black);
       ok.setForeground(Color.red);
       cancel.setBackground(Color.black);
       cancel.setForeground(Color.red);
       ok.setFont(font14);
       cancel.setFont(font14);
       aggiungiGestore(gestore,parent,selezione);  
       setLayout(null);
    
        setSize(500,200);
        setBackground(Color.black);
        
        testo.setBounds(20,20,450,80);
        add(testo);
        
         ok.setBounds(20,120,220,70);
          cancel.setBounds(240,120,220,70);
          add(ok);
          add(cancel);
         setLocation(150,150);
         pack();
         show();
         
        }
        
        
  void setMessage(String message) {
  
      etic.setText(message);
      
     }
        
   void aggiungiGestore(Gestore gestore, CreazionePosti parent,String selezione){
   
        ok.addActionListener(new ButtonHandler(gestore,parent,selezione));
        cancel.addActionListener(new ButtonHandler(gestore,parent,selezione));

        }
        
  
   // Classe che gestisce la finestra di dialogo 
  class ButtonHandler implements ActionListener{
          Gestore gestore;
          CreazionePosti parent;
          String selezione;
          
          ButtonHandler(Gestore mioGest, CreazionePosti win, String sel) {
              gestore=mioGest;
              parent=win;
              selezione=sel;
              }
          
          public void actionPerformed(ActionEvent e) {
          if (e.getActionCommand().equals("OK")){
               dispose();      
               parent.dispose();
               gestore.verificaPosto(selezione);
               }
          if (e.getActionCommand().equals("CANCEL")){dispose();}
         
         }
     }
        
        
   }