/*
La classe
RICEVE 
un messaggio da visualizzare (passato per righe), i bottoni da aggiungere e un collegamento al gestore
1. Chiama il metodo String requestMap(String) del Gestore
2. Passa il controllo alla CreazionePosti passando il riferimento al Gestore a la mappa ricevuta

*/ 
 
 import java.awt.*;
 import java.awt.event.*; 
 import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;
  
   //Classe per la gestione della finestra di dialogo
public class MessageWindow extends Frame  {
 
    CreazionePosti app;
    Gestore gestore;
    
    public MessageWindow(Finestra1 parent, String title,  String testo[],boolean modal,
    					String bottoni[],Gestore mioGest) {
    super(title);
    int lineetesto=testo.length;
    gestore=mioGest;
    
    int numbottoni=bottoni.length;
    Panel button=new Panel();
    Panel testomessaggio=new Panel();
    Font font16=new Font("Palatino",Font.BOLD,16);
    Font font14=new Font("Palatino",Font.BOLD,14);
    Font font12=new Font("Palatino",Font.BOLD,12);
    testomessaggio.setLayout(new GridLayout(lineetesto,1));
    testomessaggio.setBackground(Color.black);
    for(int i=0;i<lineetesto;++i) {
       Label etic=new Label(testo[i]);    
       etic.setFont(font14);
       etic.setBackground(Color.black);
       etic.setForeground(Color.yellow);
       testomessaggio.add(etic);
       }
    for(int i=0;i<numbottoni;++i){
          JButton b=new JButton(bottoni[i]);
          b.addActionListener(new ButtonDialogHandler(gestore,testo,parent));
          button.add(b);
          b.setFont(font16);
          b.setBackground(Color.black);
          b.setForeground(Color.red);
    }  
   button.setBackground(Color.black);
   setBackground(Color.black);
    add("North",testomessaggio);
    add("South",button);
   
    pack();
    
        } // Fine costruttore
        
         //Classe che gestisce i bottoni della prima finestra di dialogo
class ButtonDialogHandler implements ActionListener {

    Gestore gestore;
    String[] testo;
    Finestra1 parent;
    
    ButtonDialogHandler(Gestore mioGest, String[] mess,Finestra1 win){
       gestore=mioGest;
       testo=mess;
       parent=win;
       } 
    
      public void actionPerformed(ActionEvent e) { 
            String s=e.getActionCommand();
            if (s.equals("CANCELLA")){      
            dispose();
            }
            if (s.equals("CONFERMA")){
              String settore=testo[2].substring(testo[2].length()-1,testo[2].length());
              dispose();
              parent.dispose();
              String map=gestore.requestMap(settore);
              if(map==null) gestore.restart();
              app=new CreazionePosti(map,gestore);
                          
                        
              }
              
              
         }
      }
      
   } // Fine classe Dialog
  
  