/*
La classe
RICEVE 
un messaggio da visualizzare (passato per righe), i bottoni da aggiungere e un collegamento al gestore
1. Chiama il metodo String requestMap(String) del Gestore
2. Passa il controllo alla CreazionePosti passando il riferimento al Gestore a la mappa ricevuta

*/ 
 
 import java.awt.*;
 import java.awt.event.*; 
 import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;
  
   //Classe per la gestione della finestra di dialogo
public class cashWindow extends JFrame  {
    
   public static int WIDTH=400;
   public static int HEIGHT=210;
   
    JLabel n=new JLabel("NOME");
    JLabel c=new JLabel("COGNOME");
    JLabel testomessaggio=new JLabel(" Clicca OK quando hai ricevuto il pagamento");
    JButton ok=new JButton ("OK");
    JButton quit=new JButton("QUIT");
    JTextField nome=new JTextField();
    JTextField cognome=new JTextField();   
    Gestore gestore;
    
    public cashWindow(Gestore mioGest,String user,String pass) {
    
    super("CONFERMA DI PAGAMENTO");
    
    gestore=mioGest;
    
   
    
    Font font16=new Font("Palatino",Font.BOLD,16);
    Font font14=new Font("Palatino",Font.BOLD,14);
    Font font12=new Font("Palatino",Font.BOLD,12);
    
    setSize(WIDTH,HEIGHT); 
    setLocation(200,200);
    
    getContentPane().setLayout(null);  
    
    testomessaggio.setBounds(25,10,370,40);
    n.setBounds(10,50,80,30);
    nome.setBounds(140,50,170,30);
    c.setBounds(10,90,100,30);
    cognome.setBounds(140,90,170,30);
    ok.setBounds(10,140,160,60);
    quit.setBounds(230,140,160,60);
    
    addWindowListener(new WindowHandler(gestore,user,pass));
    getContentPane().setBackground(Color.black);
    n.setBackground(Color.black);
    c.setBackground(Color.black);
    n.setFont(font16);
    c.setFont(font16);
    nome.setFont(font16);
    cognome.setFont(font16);
    
    ok.addActionListener(new ButtonDialogHandler(gestore,user,pass));
    quit.addActionListener(new ButtonDialogHandler(gestore,user,pass));

    testomessaggio.setFont(font16);
    testomessaggio.setBackground(Color.black);
    testomessaggio.setForeground(Color.red); 
    ok.setFont(font16);
    ok.setBackground(Color.black);
    ok.setForeground(Color.red);  
    quit.setFont(font16);
    quit.setBackground(Color.black);
    quit.setForeground(Color.red);   
     
    getContentPane().add(testomessaggio);
    getContentPane().add(n);
    getContentPane().add(c);
    getContentPane().add(nome);
    getContentPane().add(cognome);
    getContentPane().add(ok);
    getContentPane().add(quit);
    
    setBackground(Color.black);
   
    show();
    
} // Fine costruttore


public static void main(String []args){

  cashWindow x=new cashWindow(null,null,null);
  
  }
  
  
    // Classe che gestisce la chiusura della finestra    
 class WindowHandler extends WindowAdapter {
      Gestore gestore;
      String utente,pwd;
  
   WindowHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       }
       
   public void windowClosing(WindowEvent e) {
      dispose();
      payWindow win=new payWindow(gestore,utente,pwd);
     }
   }//Fine WindowHandler()  
   
//Classe che gestisce i bottoni 
class ButtonDialogHandler implements ActionListener {

    Gestore gestore;
    String utente,pwd;
        
    ButtonDialogHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       } 
    
      public void actionPerformed(ActionEvent e) { 
            String s=e.getActionCommand();
            if (s.equalsIgnoreCase("QUIT")){//Se clicco QUIT
            dispose();
            payWindow win=new payWindow(gestore,utente,pwd);//ritorno alla finestra di scelta del pagamento
            }
            if (s.equalsIgnoreCase("OK")){
              String nomeUtente=nome.getText();
              String cognomeUtente=cognome.getText();
              if((nomeUtente.equals(""))||(cognomeUtente.equals(""))){
                     cashWindow win=new cashWindow(gestore,utente,pwd);
               }
               else{
             dispose();
              String message="CASH."+nomeUtente+"#"+cognomeUtente;
              gestore.payMethod(message,utente,pwd);
             }
           }
         }
      }
      
      
      
      
   } // Fine classe Dialog
  
  