/*
DA FARE:
Controlli su import, variabili, costruttori
*/ 
 
 import java.awt.*;
 import java.awt.event.*; 
 import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;
  
   //Classe per la gestione della finestra di dialogo
public class confirmWindow extends JFrame  {
    
   public static int WIDTH=400;
   public static int HEIGHT=150;
   
    Gestore gestore;
    
    public confirmWindow(Gestore mioGest,String user,String pass) {
    
    super("ESCI O RIPARTI ?");
    
    gestore=mioGest;
    
    JLabel testomessaggio=new JLabel(" Vuoi uscire o ripartire?");
    JButton ok=new JButton ("RESTART");
    JButton quit=new JButton("QUIT");
    JPanel scelta=new JPanel();
     JPanel msg=new JPanel();
    
    Font font16=new Font("Palatino",Font.BOLD,16);
    Font font14=new Font("Palatino",Font.BOLD,14);
    Font font12=new Font("Palatino",Font.BOLD,12);
    
    setSize(WIDTH,HEIGHT); 
    setLocation(200,200);
    
    addWindowListener(new WindowHandler(gestore,user,pass));
    scelta.setBackground(Color.black);
    msg.setBackground(Color.black);
    msg.add(testomessaggio);
    
    ok.addActionListener(new ButtonDialogHandler(gestore,user,pass));
    quit.addActionListener(new ButtonDialogHandler(gestore,user,pass));
    scelta .add(ok);
    scelta .add(quit);

    testomessaggio.setFont(font16);
    testomessaggio.setBackground(Color.black);
    testomessaggio.setForeground(Color.red); 
    ok.setFont(font16);
    ok.setBackground(Color.black);
    ok.setForeground(Color.red);  
    quit.setFont(font16);
    quit.setBackground(Color.black);
    quit.setForeground(Color.red);   
    
    getContentPane().add("South",scelta);
    getContentPane().add(msg);
     setBackground(Color.black);
   
    
    show();
    
} // Fine costruttore


    // Classe che gestisce la chiusura della finestra    
 class WindowHandler extends WindowAdapter {
      Gestore gestore;
      String utente,pwd;
  
   WindowHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       }
       
   public void windowClosing(WindowEvent e) {
      dispose();
      payWindow win=new payWindow(gestore,utente,pwd);
     }
   }//Fine WindowHandler()  
   
//Classe che gestisce i bottoni 
class ButtonDialogHandler implements ActionListener {

    Gestore gestore;
    String utente,pwd;
    Initialize win;
        
    ButtonDialogHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       } 
    
      public void actionPerformed(ActionEvent e) { 
            String s=e.getActionCommand();
            if (s.equalsIgnoreCase("QUIT")){//Se clicco QUIT
                dispose();        
                gestore.closeConnection();
                System.exit(0);      
            }
            if (s.equalsIgnoreCase("RESTART")){
              dispose();
              gestore.closeConnection();
              win=new Initialize(utente,pwd);
            
            }
            
         }
      }
      
      
      
      
   } // Fine classe Dialog
  
  