import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.ProgressMonitor;
import java.net.*;
import java.util.*;
import java.util.GregorianCalendar;

class GestoreTransazione {

     Socket connection;
     BufferedReader  inStream;
     DataOutputStream outStream;
     String inLine;
     
 public GestoreTransazione(Socket connection,BufferedReader  inStream,DataOutputStream outStream){
          this.connection=connection;
          this.inStream=inStream;
          this.outStream=outStream;
    }
    
    
 /*Usato per negoziare la comunicazione con il server2 I MSG vanno spediti due volte
 Ritorna
 0: in caso di errore
 1: se tutto  ok
 */
 int connect(){
    
    int ans=sendMessage("AS");//mi faccio riconoscere come Server
    if(ans!=1){//Se c' un errore
                      return 0;
    }          
    String message=receiveMessage();//e aspetto la risposta

    if(message.equalsIgnoreCase("OK")) return 1;
 
     else return 0;
 }//Fine connect()
 
 
/*Usato per verificare lo stato del posto sul server2
Ritorna
OK se il posto  E sull'altro server
NO se il posto  F sull'altro server
OCC se il posto  P sull'altro server
ERR in caso di errore o crash dell'altro server
*/
 String checkPlace(String settore,String fila, String posto){
     
     String message;
     int ans=sendMessage("CHECK");//Comunico all'altro server che voglio info su un posto
     if(ans==1){
         message=receiveMessage();//e aspetto la risposta
         if(message.equalsIgnoreCase("OK")){
     				ans=sendMessage(settore+"."+fila+"-"+posto);//spedisco richiesta per il posto
     				if(ans==1){
     				     message=receiveMessage();//e attendo risposta
     				     if(message==null) return"ERR";
 				     else return message;   
 				 }
 				 else return"ERR";  				   
         }
         else return"ERR";
      }
    else return "ERR";
    
 }//Fine checkPlace();
 
 /*Risolve le controversie sulla disponibilt
 Ritorna
 0 se il posto  dell'altro server
 1 se  mio
 */
 int setPriority(GregorianCalendar dataPrenotaz){
 
    String ora=Integer.toString((dataPrenotaz.get(Calendar.HOUR)));
    String minuti=Integer.toString((dataPrenotaz.get(Calendar.MINUTE)));
    String secondi=Integer.toString((dataPrenotaz.get(Calendar.SECOND)));
    String message=ora+":"+minuti+"."+secondi;
    
    int ans=sendMessage(message);// lo spedisco al server
    message=receiveMessage();//e attendo risposta
    if((message.equalsIgnoreCase("OK"))||(message==null)){//il posto  mio
         return 1;
    }
    if(message.equalsIgnoreCase("NO")) {//il posto non  mio
        return 0;
    }
    
    return 0;
 }//Fine setPriority
 
 //Spedisce al server il messaggio di abort
 void abortMethod(){
     
     int ans=sendMessage("ABT");
   
 }//Fine abortMethod()
 
 
 /*Usato per spedire conferma di pagamento all'altro server
 Ritorna:
 1 se il server da conferma
 0 se non ricevo conferma
 */
 int payMethod(String dati){
     
     String message="SET."+dati;
     int ans=sendMessage(message);
     String answer=receiveMessage();
     if(answer==null) return 0;
     if(answer.equalsIgnoreCase("OK")) 
           return 1;
     else return 0;
       
 }//Fine payMethod()
 
 void confirmMethod(){
 
    int ans=sendMessage("TERM");
 
 }//Fine confirmMethod()
 
  //Usata per ricevere messaggi       
  String receiveMessage() {     
       
            try{
              
              inLine=inStream.readLine();

             }catch(IOException ex) {return null;}   
           
               return inLine;
  }//Fine sendMessage();
            
            
//Usata per spedire messaggi            
     int sendMessage(String message) {
     
         try{
       
        for(int i=0;i<message.length();++i) 
           outStream.write(message.charAt(i));
           outStream.write(13);
           outStream.write(10);
           outStream.flush();
           
          }catch (IOException ex) {//Se c' un'eccezione rispedisco e riprovo
                    try{
       
        		for(int i=0;i<message.length();++i) 
          			 outStream.write(message.charAt(i));
         			 outStream.write(13);
           			 outStream.write(10);
          			 outStream.flush();
           
                      }catch (IOException ioex) {//se fallisco di nuovo dichiaro fallimento
                              return 0;}
          }  
          return 1; 
     
     
     }//FIne sendMessage()
     
     
     
     
     
 }//Fine GestoreTransazione();