import java.lang.System;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.ProgressMonitor;
import java.util.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Date;
import java.net.Socket;
import java.io.*;
import java.net.*;

public class updateObj {
    
    Vector lost=new Vector();
    Database database;
    String server2;
    int server2Port;
    int UPD;
    Socket connection;
    BufferedReader inStream;
    DataOutputStream outStream;
    
    
//Costruttore
public updateObj(String server2,int server2Port){
    
    this.database=database;
    this.server2=server2;
    this.server2Port=server2Port;
    
}//Fine costruttore

void incUPD(){
   
    ++UPD;
}

void decUPD(){

   --UPD;
 }
 
 int getUPD(){
 
    return UPD;
}

void setUPD(int val){
   
   UPD=val;
}

 
//Aggiunge un elemento al vettore dei persi a partire dal posto ricevuto
public void addLost(Ticket posto){
  
  TicketLost postoPerso=new TicketLost(posto);
  lost.addElement(postoPerso);
  
}//Fine addLost


//Elimina l'elemento allo specificato indice
public void removeLost(int index){

   lost.removeElementAt(index);
   
}//Fine removeLost


//Cerca eventuali posti di cui non richiedere di nuovo lo stato
public void checkLost(){
   
   int dim=lost.size();
   for(int i=0;i<dim;++i){
       
       TicketLost postoPerso=(TicketLost) lost.elementAt(i);
       if((postoPerso.check)==3){//se c' un posto che non devo pi updatare
            removeLost(i);
            decUPD();//scalo il valore di UPD
       }
    }
}//Fine checkLost


   
//Crea la connessione a la richiesta di UPDRITORNA true se  stato aggiornato
boolean update(Database database){
   
   boolean updateVar=false;
   boolean alone=false;
   
           try{
              connection=new Socket(server2,server2Port);
        }catch(UnknownHostException uhe) {//se c' un errore
        
           try{//riprovo una seconda volta
                 connection=new Socket(server2,server2Port); 
               }catch(UnknownHostException uhe1) {//non c' nessun server
                       alone=true;   
                           }
               catch(IOException ie1) {
                       alone=true;
                                                      }
                                
           }
           
         catch(IOException ex) {//se  un server sconosciuto
 
           try{//riprovo una seconda volta
                 connection=new Socket(server2,server2Port); 
               }catch(UnknownHostException uhe2) {//non c' nessun server
                       alone=true;   
                          		 }
               catch(IOException ie2) {
                        alone=true;
                                                      }
                                                            
           }
           
           
    if(!alone) {//Se c' un altro server     
       
      try{//creazione dei flussi
           outStream=new DataOutputStream(connection.getOutputStream());
           inStream=new BufferedReader(new InputStreamReader(connection.getInputStream()));
      }catch(IOException ex) {
           return false;//Come se non ci fosse l'altro server
       }
          
       int ans=sendMessage("AS");//Richiedo l'accesso come server
       
       if(ans==1){//se il messaggio  stato spedito
       String message=receiveMessage();//attendo conferma
       
       if(message.equalsIgnoreCase("OK")){
            ans=sendMessage("UPD");//richiedo l'update
            if(ans==1){
              message=receiveMessage();
              if(message.equalsIgnoreCase("OK")){
                updateVar=checkUPD(database);
                ans=sendMessage("TERM");
                closeConnection();
             }
              else {closeConnection();
                  return false;}
           }
           else {closeConnection();
                  return false;}
         }
         else {closeConnection();
                  return false;}
      }
      else {closeConnection();
                  return false;}

}

  return updateVar;

}//Fine update



//checka l'aggiornamento
boolean checkUPD(Database database){

     String settore,fila,posto,message;
     boolean update=false;
     int dim=lost.size();
     int ans;
     int i=0;
     
     while(i<dim){  
        TicketLost postoPerso=(TicketLost) lost.elementAt(i);
        settore=(String)postoPerso.settore;
        fila=(String) postoPerso.fila;
        posto=(String)postoPerso.posto;
        message=settore+"."+fila+"-"+posto;
        ans=sendMessage(message);
        if(ans==0){//se ho problemi di link con il server
               closeConnection();
               return false;//fallisco
        }
        message=receiveMessage();
        if(message==null){//se ho problemi di link con il server
               closeConnection();
               return false;//fallisco
        }
        if(message.equalsIgnoreCase("E")){//se di l lo stato  consistente
            database.setTicket(settore,fila,posto,message);//aggiorno il mio
            update=true;
            removeLost(i);//rimuovo il posto dalla lista
            decUPD();//e decremento il n di Update da fare
            i=i+1;
        }
        if(message.startsWith("F")){//se di l lo stato  consistente
            int k=message.indexOf('.');
            int n=message.length();
            String stato=message.substring(0,k);
            String nome=message.substring(k+1,n);
            database.setTicket(settore,fila,posto,stato);//aggiorno il mio
            database.setName(settore,fila,posto,nome);
            update=true;
            removeLost(i);//rimuovo il posto dalla lista
            decUPD();//e decremento il n di Update da fare
            i=i+1;
        }
        if(message.equalsIgnoreCase("P")){//se lo stato di l  INCONSISTENTE
           postoPerso.incCheck();
           i=i+1;
        }   
     }
return update;

}//Fine checkUPD

   
void closeConnection(){   
     
           try{
               connection.close();//e chiudo la connessione
           }catch(IOException ex) {System.out.println("Errore chiudendo la connessione");}
           
 }//Fine closeConnection        
   
/*
--------------------------------------------------------------------------------------------------------------------------------------------------
METODI DI SERVIZIO PER LA RICEZIONE E LA SPEDIZIONE DEI MESSAGGI */

//Usata per ricevere messaggi       
  String receiveMessage() {     
            
            String inLine;
      
            try{
              
              inLine=inStream.readLine();
              

             }catch(IOException ex) {return null;}   
               
                return inLine;
            }
            
            
//Usata per spedire messaggi            
     int sendMessage(String message) {
     
         try{
       
        for(int i=0;i<message.length();++i) 
           outStream.write(message.charAt(i));
           outStream.write(13);
           outStream.write(10);
           outStream.flush();
           
          }catch (IOException ex) {//Se c' un'eccezione rispedisco e riprovo
                    try{
       
        		for(int i=0;i<message.length();++i) 
          			 outStream.write(message.charAt(i));
         			 outStream.write(13);
           			 outStream.write(10);
          			 outStream.flush();
           
                      }catch (IOException ioex) {//se fallisco di nuovo dichiaro fallimento
                              return 0;}
          }  
          return 1; 
     
     
     }//Fine sendMessage()




}//Fine classe