/*
La classe:
RICEVE i parametri di connessione, la user e la password dell'utente
1. Crea l'oggetto Cliente che gestisce a livello pi basso il collegamento con il server
2. Gestisce gli oggetti che compongono l'applicazione client
*/


import java.lang.String;
import java.lang.Object.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.*;
import java.io.LineNumberReader;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.IOException;
import javax.swing.ProgressMonitor;
import java.io.FileOutputStream;
import java.io.*;
import java.lang.System;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.net.SocketException;
import java.lang.System;
import java.io.*;
import java.net.Socket;

public class Gestore {
    
    String prices,utente, pass,message,prezzi;
    Socket connection;
    Initialize app;
    BufferedReader inStream;
    DataOutputStream outStream;
    int ans;
    SystemMessage finestra;
    SystemMessage2 finestra2;
    Finestra1 scelta;
    CreazionePosti mappa;
    Cliente client=new Cliente();
    
//Costruttore    
public Gestore(String destination,String altdestination, int port, int altport,String user,String pwd,int op){

      utente=user;
      pass=pwd;

      
     connection=client.connetti(destination,port,altdestination,altport);
     if(connection==null) {
            finestra=new SystemMessage("Impossibile accedere ai server. Riprovo?");
           }
      else{     
      int a;
      ans=client.accRequest(utente, pass);
      if(ans!=1) {
                     if (ans==0) {
                              finestra=new SystemMessage("Accesso negato. Riprovo ?");
                              }
                              
                     if(ans<0) {
                              finestra=new SystemMessage("Errore nel richiedere l'accesso. Riprovo?");
                              }
                       }
                       
    if(ans==1){
    
    message=receivePrices(client);   
    if((message.equals(" "))||message==null){
                  restart();}
                  
    prezzi=elaboraPrezzi(message);
    String costi []=new String[8];//Crea l'array dei prezzi da passare per l'elaborazione alla Finestra1
    int n,x;
    
    for(int i=0;i<7;++i) {
         n=prezzi.length();
         x=prezzi.indexOf(' ');
         costi[i]=prezzi.substring(0,x);
         prezzi=prezzi.substring(x+1,n);
         }
     costi[7]=prezzi;   

    scelta=new Finestra1(costi,Gestore.this,op);
  }
  }
}// Fine costruttore

//usata per resettare e ripartire in caso di errori
void restart(){
 
   Initialize app=new Initialize(utente,pass);

}//FIne restart

String requestMap(String settore) {

    int ans;
    String map="";
    
    ans=client.sendMessage(settore);
    if(ans==1){//se  stato spedito
  	  String message=client.receiveMessage();//attendo risposta
  	  if(message==null){//se  crashato di l
  	  return null;
  	  }
    	  else{map=settore+message;}
    }
    return map;
   
}

//Riceve dal server i prezzi di settori 
String receivePrices(Cliente client) {

    String prezzi=" ";      
    ans=client.sendMessage("RDY");
     if(ans==-1){
                 ans=client.sendMessage("RDY");
                 if(ans==-1){return prezzi;}
                 else {prezzi=client.receiveMessage();
                           return prezzi;}
          }
      else {prezzi=client.receiveMessage();
                            return prezzi;}
      
 }
 
 //Usata per chiudre la connessione
 void closeConnection(){
 
  ans=client.sendMessage("TERM");
  client.closeConnection();
 
 }//Fine closeConnection();
 
 
 
 //Elimina la parte di info e ritorna solo i prezzi 
 String elaboraPrezzi(String message) {
    
    String prezzi;
    int n=message.indexOf(' ');
    prezzi=message.substring(n+1,message.length());
    return prezzi;
     
} 


//Chiama il server alla verifica del posto e all'aggiornamento in concorrenza del db
 void verificaPosto(String selezione) {
     
     int ans=client.sendMessage(selezione);   
     if(ans==1){
        String message=client.receiveMessage();
     	 if(message==null) restart();

     	if(message.equalsIgnoreCase("PAY")) {
             payWindow win=new payWindow(Gestore.this,utente,pass);
     	}
    	 else {
         	 finestra2=new SystemMessage2("Posto prenotato da un'altro processo. Vuoi effettuare un'altra prenotazione?",
                           Gestore.this,utente,pass);			
     	}
     }
     
    else{restart();}
    							
  }//Fine verificaPosto()
  
 //Usata per confermare il pagamento e chiudere la transazione del posto
 void payMethod(String message,String user,String pwd){
 
 try{
 
   if(message.startsWith("CC")){//pagamentro con CC
        int ans=client.sendMessage(message);
        if(ans==1){
        String answer=client.receiveMessage();
         if(answer.equalsIgnoreCase("OK")){//POSTO PRENOTATO!!!!! Implemento una finestra di dialogo
            ans=client.sendMessage("TERM");
            transWindow x=new transWindow(user,pwd,"POSTO PRENOTATO");
       }
        if(answer.equalsIgnoreCase("NO")){//CONTO INESISTENTE!!  
        ccWindow x=new ccWindow(Gestore.this,user,pwd); //riparto dalla ccWindow
        }
        if(answer.equalsIgnoreCase("INS")){//CREDITO INSUFFICIENTE!! 
        ccWindow x=new ccWindow(Gestore.this,user,pwd);//riparto dalla ccWindow
      }
        if(answer==null) restart();
   }
   
   else{restart();} 
   
 }// Fine pagamento CC
    
    if(message.startsWith("CASH")){//pagamento CASH richiede solo conferma del posto
       int ans=client.sendMessage(message);
       if(ans==1){
       String answer=client.receiveMessage();
       if(answer.equalsIgnoreCase("OK")){//POSTO PRENOTATO!!!!! Implemento una finestra di dialogo
          ans=client.sendMessage("TERM");
          transWindow x=new transWindow(user,pwd,"POSTO PRENOTATO");
          
       }
       if(answer==null) restart();
         
     }
     
   else{restart();} 
   
  }//Fine pagamento CASH
   
  if(message==null) restart();  
   
   }catch(NullPointerException npe) {restart();
         }
   
}//Fine payMethod()
     
     
 }//Fine classe