/*Restano da implementare:
1. La classe che gestisce i pannelli
2. La pressione del bottone SAVE che aggiorna il file di preferenze*/

import java.io.IOException;
import java.io.FileOutputStream;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;

public class SetupWindow extends JFrame{
  public static int LARG=500;
  public static int LUNG=500;
  public static String TITLE="SETUP WINDOW";
  
 //Parametri dei Font, bottoni, label e aree di testo da utilizzare dei pannelli 
  
   Font font18= new Font("Palatino",Font.BOLD,18);
   Font font14= new Font("Palatino",Font.BOLD,14);
   Font font16= new Font("Palatino",Font.BOLD,16);   
   
  String [] parametri={"localhost","1234","localhost","1235","1"};
  String indirizzoserver1=parametri[0];
  String portaserver1=parametri[1];
  String indirizzoserver2=parametri[2];
  String portaserver2=parametri[3];
  String [] list={"SERVER 1","SERVER 2","PREFERENZE"};  
  
  JTabbedPane schedario=new JTabbedPane(); 
  JPanel server1=new JPanel();
  JPanel server2=new JPanel();
  JPanel preferenze=new JPanel();
  JPanel bottoni=new JPanel();
  JPanel [] pannelli={server1,server2,preferenze};
  String [] aiuto={"Parametri Server 1","Parametri Server 2","Accesso ai server"};
  
  JButton save=new JButton("SAVE");
  JButton cancel=new JButton("CANCEL");
  
  JTextField viewserver1=new  JTextField(indirizzoserver1);
   JTextField  viewport1=new  JTextField(portaserver1);
   JTextField viewserver2=new  JTextField(indirizzoserver2);
   JTextField viewport2=new  JTextField(portaserver2);
  
  JRadioButton s1=new JRadioButton("SERVER 1");
  JRadioButton s2=new JRadioButton("SERVER 2"); 
  
  
  // Costruttore
  
  public SetupWindow(){
    super(TITLE);
    schedario.setFont(font14);
    buildGUI();
    setSize(LUNG,LARG);
    schedario.setBackground(Color.white);
    schedario.setForeground(Color.darkGray);
    setBackground(Color.black);
    show();
    }
    
  //Creazione interfaccia a pannelli  
    
   void buildGUI() {          
         for(int i=0;i<list.length;++i) {
              pannelli[i].setBackground(Color.white);
              pannelli[i].setForeground(Color.black);
              schedario.addTab(list[i],null,pannelli[i],aiuto[i]);
            }
         aggiungiComponenti();
         setupBottoni(save, cancel);
         getContentPane().add("South",bottoni);
         getContentPane().add("Center",schedario);
         getContentPane().setBackground(Color.black);
      }
    
  // creazione pannelli  
    
  void aggiungiComponenti() {
     setupServer1();
     setupServer2();
     setupPreferenze();
  }
  
 //Pannello settaggi server 1 
  
  void setupServer1() {
    
       aggiungititolo("SERVER 1");
       server1.setLayout(null);      
       
       JLabel messaggio1=new JLabel("Indirizzo Server 1 ");
       JLabel messaggio2=new JLabel("Porta del Server 1 ");
       
       messaggio1.setForeground(Color.red);
       messaggio2.setForeground(Color.red);
       
       messaggio1.setBounds(50,80,150,20);
       messaggio2.setBounds(50,200,150,20);
       viewserver1.setBounds(250,80,150,25);
       viewport1.setBounds(250,200,150,25);
       
       viewserver1.setFont(font16);
       viewport1.setFont(font16);
       messaggio1.setFont(font16);
       messaggio2.setFont(font16);
       
       server1.add(messaggio1);
       server1.add(messaggio2);
       server1.add(viewserver1);
       server1.add(viewport1);
    
    }
    
  //Pannello settaggi server 2  
    
     void setupServer2() {
    
       aggiungititolo("SERVER 2");
       server2.setLayout(null);      
       
       JLabel messaggio1=new JLabel("Indirizzo Server 2 ");
       JLabel messaggio2=new JLabel("Porta del Server 2 ");
       
       
       messaggio1.setForeground(Color.red);
       messaggio2.setForeground(Color.red);
       
       viewserver2.setBounds(250,80,150,25);
       viewport2.setBounds(250,200,150,25);
       messaggio1.setBounds(50,80,150,20);
       messaggio2.setBounds(50,200,150,20);
       
       viewserver2.setFont(font16);
       viewport2.setFont(font16);
       messaggio1.setFont(font16);
       messaggio2.setFont(font16);
       
       server2.add(messaggio1);
       server2.add(messaggio2);
       server2.add(viewserver2);
       server2.add(viewport2);
      
    }
    
  // pannello settaggi preferenze  
    
    void setupPreferenze() {
       
       aggiungititolo("PREFERENZE");
       preferenze.setLayout(null);
       
       JLabel messaggio=new JLabel("SELEZIONA MAIN SERVER");
       ButtonGroup servergroup=new ButtonGroup();
       JPanel serverpanel=new JPanel();
       
       s1.setFont(font16);
       s2.setFont(font16);
       messaggio.setFont(font16);
       
       s1.setBackground(Color.lightGray);
       s1.setForeground(Color.blue);
       s2.setBackground(Color.lightGray);
       s2.setForeground(Color.blue);
       messaggio.setForeground(Color.black);
       
       serverpanel.setBounds(300,120,100,40);
       messaggio.setBounds(70,130,280,25);
       
       serverpanel.add(s1);
       serverpanel.add(s2);
       servergroup.add(s1);
       servergroup.add(s2);
       serverpanel.setLayout(new GridLayout(2,1));
       preferenze.add(serverpanel);
       preferenze.add(messaggio);
       }
       
   //Pannello settaggi database    
       
       
 // settaggio font e colori dei bottoni principali - aggiunta alla finestra
       
   void setupBottoni(JButton bottone1,JButton bottone2) {
     
      bottone1.setFont(font18);
      bottone2.setFont(font18);
      
      bottoni.setBackground(Color.black);
      bottone1.setForeground(Color.red);
      bottone1.setBackground(Color.black);
      bottone2.setForeground(Color.red);
      bottone2.setBackground(Color.black);
      
      bottone1.addActionListener(new ButtonHandler());
      bottone2.addActionListener(new ButtonHandler());
      bottoni.add(bottone1);
      bottoni.add(bottone2);
  }
 
// Metodo che aggiunge il titolo ad ogni pannello 
 
 void aggiungititolo(String titolo) {
 } 
  
    
  
 //Classe che gestisce i pannelli
 
 
 
//Classe che gestrisce i bottoni
class ButtonHandler implements ActionListener {
      public void actionPerformed(ActionEvent e) { 
            String s=e.getActionCommand();
            if (s.equals("CANCEL")){      
            dispose();
            }
             if (s.equals("SAVE")){
               String server1=viewserver1.getText(); 
               String server2=viewserver2.getText(); 
               String port1=viewport1.getText(); 
               String port2=viewport2.getText(); 
               String main=getMainserver();
               dispose();
               saveFile(server1,server2,port1,port2,main);
            }
         }
  
  
  
String getMainserver(){
   
    String s="1"; 
    
    if(s1.isSelected()) s="1";
    if(s2.isSelected()) s="2";
     
    return s;

   }//fine getMainserver()     
   
    void saveFile(String server1,String server2,String port1,String port2,String main){
    
        String [] head={"SERVER1","SERVER2","PORTAS1","PORTAS2","MAINSERVER"};
        String [] parametri={server1,server2,port1,port2,main};
         try{
         
         FileOutputStream outStream=new FileOutputStream("preferences.txt");
         for(int i=0;i<5;i++) {
              String s=head[i]+": "+parametri[i]+"\n";
              for(int k=0;k<s.length();++k) {
                  outStream.write(s.charAt(k));}
            }
         outStream.close();
          }  catch (IOException ex) {System.out.println("Errore nella lettura del file di preferenze. Riprovo?");} 
         
  }//Fine save()


}//Fine ButtonHandler()
      
      

      

  
  
  
  
}//Fine setupWindow


 