import java.awt.*;
import java.awt.event.*; 
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;

public class ccWindow extends JFrame{
  
  public static int LUNG=340;
  public static int LARG=250;
  
  //Componenti
  
  Font font18= new Font("Palatino",Font.BOLD,18);
  Font font14= new Font("Palatino",Font.BOLD,14);
  Font font16= new Font("Palatino",Font.BOLD,16);    
  
  JPasswordField ccID= new JPasswordField();
  JPasswordField password= new JPasswordField();
  JTextField nome=new JTextField();
  JTextField cognome=new JTextField();
  
  JLabel cc=new JLabel("CC Number");
  JLabel n=new JLabel("Nome:");
  JLabel c=new JLabel("Cognome:");
  JLabel p=new JLabel("Password:");

  JButton bottone=new JButton("SEND");
  
   //Costruttore 
  
  public ccWindow(Gestore gestore,String user,String pass) {
  
  super("Inserisci numero di carta");
  addWindowListener(new WindowHandler(gestore,user,pass));
  buildGUI(gestore,user,pass); 
  setSize(LUNG,LARG);
  setLocation(200,200);
  setForeground(Color.red);
  show();
  
  }
  
   //Costruisce la parte grafica della finestra 
  void buildGUI(Gestore gestore,String user,String pass) {
    
      getContentPane().setLayout(null);
     bottone.setFont(font16);
     cc.setFont(font16);
     n.setFont(font16);
     c.setFont(font16);
     p.setFont(font16);
     password.setFont(font16);
     ccID.setFont(font16);
     
     cc.setForeground(Color.red);
     p.setForeground(Color.red);
     password.setForeground(Color.red);
     n.setForeground(Color.red);
     c.setForeground(Color.red);
     bottone.setForeground(Color.red);
     
     n.setBounds(0,0,110,50);
     c.setBounds(0,50,110,50);
     cc.setBounds(0,100,110,50);
     p.setBounds(0,150,110,50);
     bottone.setBounds(20,200,300,50);
     nome.setBounds(110,0,220,50);
     cognome.setBounds(110,50,220,50);
     ccID.setBounds(110,100,220,50);
     password.setBounds(110,150,220,50);
     
     bottone.addActionListener(new AccessHandler(gestore,user,pass));
          
     getContentPane().add(bottone);
     getContentPane().add(ccID);
     getContentPane().add(cc);
     getContentPane().add(cognome);
     getContentPane().add(c);
     getContentPane().add(n);
     getContentPane().add(nome);
     getContentPane().add(p);
     getContentPane().add(password);
     
     
  }//Fine buildGUI
     
public static void main(String args[]){
   ccWindow app=new ccWindow(null,null,null);
   }
   
    // Classe che gestisce la chiusura della finestra    
 class WindowHandler extends WindowAdapter {
      Gestore gestore;
      String utente,pwd;
  
   WindowHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       }
       
   public void windowClosing(WindowEvent e) {
      dispose();
      payWindow win=new payWindow(gestore,utente,pwd);
     }
   }//Fine WindowHandler()  
  
  // Classe che gestisce il rilevamento di user e pwd
  class AccessHandler implements ActionListener{
       Gestore gestore;
       String utente,pwd;
       
       AccessHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       }
       
     public void actionPerformed(ActionEvent e) {
        
          String ccNumber=ccID.getText();
          String nomeUtente=nome.getText();
          String cognomeUtente=cognome.getText();
          String codice=password.getText();
          if((codice.equals(""))||(nomeUtente.equals(""))||(cognomeUtente.equals(""))||(ccNumber.equals(""))) {
                dispose();
                ccWindow app=new ccWindow(gestore,utente,pwd);
           }     
          dispose();
          String message="CC."+ccNumber+"#"+nomeUtente+"$"+cognomeUtente+"@"+codice;
          gestore.payMethod(message,utente,pwd);
         }
     }
           
}//Fine classe payWindow()