import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.sun.java.swing.plaf.motif.*;
import com.sun.java.swing.plaf.windows.*;
import javax.swing.plaf.metal.*;

public class payWindow extends JFrame{
     
   public static int WIDTH=330;
   public static int HEIGHT=150;
   public static String TITLE="Scegli il pagamento";
   
   Initialize win;
    
    //Componenti GUI della finestra
    
    ButtonGroup pagamento=new ButtonGroup();
    
    JButton select=new JButton ("SELECT");
    JButton quit=new JButton("QUIT");
    JRadioButton cc=new JRadioButton("CREDIT CARD");
    JRadioButton cash=new JRadioButton("CONTANTI");
    
    JPanel buttonchoicePanel=new JPanel();
    JPanel scelta=new JPanel();
    
    Font font12= new Font("Palatino",Font.BOLD,12);
    
    
    // Costruttore
   public payWindow(Gestore gestore,String user, String pass) {
   
   super(TITLE);
   addWindowListener(new WindowHandler(gestore,user,pass));
   buildGUI(gestore,user,pass);  
   setSize(WIDTH,HEIGHT);  
   setLocation(200,200);
   getContentPane().add("South",buttonchoicePanel);
   getContentPane().add("Center",scelta);
   setBackground(Color.red);
   show();
   
   }//Fine costruttore
   
     // Creazione dei pulsanti degli abbonamenti
    void buildGUI(Gestore gestore,String user,String pass) {   
    
   	pagamento.add(cc);
   	pagamento.add(cash);
   	scelta.add(cc);
   	scelta.add(cash);
   	
   	cc.addActionListener(new ButtonHandler(gestore,user,pass));//Aggiunta dei gestori
   	cash.addActionListener(new ButtonHandler(gestore,user,pass));
   	
   	cc.setBackground(Color.black);//Selezione colori
   	cash.setBackground(Color.black);
 	cc.setForeground(Color.white);
 	cash.setForeground(Color.white);
 	cc.setFont(font12);
 	cash.setFont(font12);
   	
   	scelta.setLayout(new GridLayout(1,2));
   	scelta.setBackground(Color.black);
        scelta.setForeground(Color.white);
    
   	setupButtonChoice(gestore,user,pass);// Completamento della componente grafica	
        setupFont();
        
   }//Fine buildGUI()
   
 // Creazione pulsanti di scelta (colore e gestori)   
 void setupButtonChoice(Gestore gestore,String user,String pass) {

   quit.setBackground(Color.black);
   select.setBackground(Color.black);
   quit.setForeground(Color.yellow);
   select.setForeground(Color.yellow);
   buttonchoicePanel.setBackground(Color.red);
   buttonchoicePanel.add(quit);
   buttonchoicePanel.add(select);
   quit.addActionListener(new ButtonHandler(gestore,user,pass));
   select.addActionListener(new ButtonHandler(gestore,user,pass));
   
}//Fine setupBottonChoice()

//Settaggio dei font
void setupFont() {

   Font font10=new Font("Palatino",Font.BOLD,10);
   Font font14=new Font("Palatino",Font.BOLD,14);
   Font font12=new Font("Palatino",Font.BOLD,12);
   select.setFont(font14);
   quit.setFont(font14);
   
   }//Fine setupFont()
   
   public static void main(String args[]){
   payWindow app=new payWindow(null,"p","p");
   }
  
 //Classe che gestisce i bottoni
 public class ButtonHandler implements ActionListener {
     Gestore gestore;
     String utente,pwd;
  
   ButtonHandler(Gestore mioGest,String user,String pass){
       gestore=mioGest;
       utente=user;
       pwd=pass;
       }
       
  public void actionPerformed(ActionEvent e) {
      String etichetta=e.getActionCommand();
      String selezione="";
      
      if (etichetta.equalsIgnoreCase("QUIT"))   {
         dispose();      
         confirmWindow x=new confirmWindow(gestore,utente,pwd);
      }
      
     //Ricerca etichetta selezionata   
      boolean trovato=false;       
      if(etichetta.equalsIgnoreCase("SELECT")) {//Verifico quale dei due pulsanti ho selezionato
             if(cc.isSelected()){
      	        trovato=true;
      	        selezione="CC";
      	        }
      	      if(cash.isSelected()){
      	        trovato=true;
      	        selezione="CASH";
      	        }
          }
         
          if(trovato) {        
              if(selezione.equalsIgnoreCase("CC")){
                  dispose();
                  ccWindow dialog=new ccWindow(gestore,utente,pwd);
                  dialog.setLocation(200,200);
                  dialog.show();
             }
          if(selezione.equalsIgnoreCase("CASH")){
                  dispose();
                  cashWindow dialog=new cashWindow(gestore,utente,pwd);
                  dialog.setLocation(200,200);
                  dialog.show();
          }
       }
     }  
   }// Fine ButtonHandler
   
       // Classe che gestisce la chiusura della finestra    
 class WindowHandler extends WindowAdapter {
      Gestore gestore;
      String utente,pwd;
  
   WindowHandler(Gestore mioGest,String user,String pass){
         gestore=mioGest;
         utente=user;
         pwd=pass;
       }
       
   public void windowClosing(WindowEvent e) {
         dispose();      
         confirmWindow x=new confirmWindow(gestore,utente,pwd);
     }
   }//Fine WindowHandler()  
   
   
}//Fine classe payWindow()