/*DA IMPLEMENTARE:
1. La ricerca di un altro server in caso di assenza del file di database(NON pu farlo il thread, deve farlo qui)
2. La ridirezione su un output di qualsiasi genere degli errori (creare una classse Errore......)
3. La definizione del database come collezione di classi Place;


*/
import java.lang.System;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.ProgressMonitor;
import java.util.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.util.Date;

public class Database {
   
   String DB_FISICO="database.txt";
   String DATAFILE="'dati.txt";
   Vector database=new Vector();
   Ticket abbonamento,biglietto;
   
   int COMMIT=0;
   
   boolean DBFREE=true;
      
   FileReader inFile;
   LineNumberReader inLines;
   
   String settore,INFO,posto,fila,stato;
   int dim;
   updateObj aggiornamento;
   

//Costruttore
public Database(updateObj aggiornamento){  
  
  this.aggiornamento=aggiornamento;
  copyDatabase(aggiornamento);
  
}//Fine Costruttore



//Ritorna il nome relativo al posto
public synchronized String getName(String settore,String fila,String posto){
     
     Ticket abbonamento;
     String nome="";
   
     int dim=database.size();
      for(int i=0;i<dim;++i){
         abbonamento=(Ticket) database.elementAt(i);
         if((abbonamento.settore).equals(settore)){//se  il settore che cerchiamo
            if(((abbonamento.posto).equals(posto))&& ((abbonamento.fila).equals(fila)))//e il posto che cerchiamo
               {nome=abbonamento.nome;
                 break;}
          }
       }
     return nome;

}//Fine getName



//Usata per creare la copia logica del database fisico
public synchronized void copyDatabase(updateObj aggiornamento){
  
  String inputLine;
  try{
     FileReader inFile=new FileReader(DB_FISICO);
     LineNumberReader inLines= new LineNumberReader(inFile);
     settore="A";
     while((inputLine=inLines.readLine())!=null) {//Creo la copia logica del database sul vettore database
          
           if(inputLine.startsWith("INFO")) {
                 setInfo(inputLine);
                 }
         if(inputLine.startsWith("SETTORE")){
                int n=inputLine.indexOf(' ');
                String lettera=inputLine.substring(n+1,n+2);
                settore=lettera;
               }
          if((inputLine.indexOf('-'))!=-1){
               int x=inputLine.length();
               int y=inputLine.indexOf('-');
               String fila=inputLine.substring(0,y);
               String posto=inputLine.substring(y+1,inputLine.indexOf(' '));
               String stato=inputLine.substring(x-1,x);
               abbonamento=new Ticket();
               abbonamento.settore=settore;
               abbonamento.fila=fila;
               abbonamento.posto=posto;
               abbonamento.modo=stato;
               database.addElement(abbonamento); //aggiunge l'elemento al DBLOGICO
               if(stato.equals("P")) {//verifica se ci sono posti"vacanti"
                   aggiornamento.incUPD();//e aggiorna la variabile UPD
                   aggiornamento.addLost(abbonamento);//e la lista dei posti vacanti
               }
          }
      }
      inFile.close();
      
    }catch(IOException ex){System.out.println("File di database not found");}//Prelevare una copia dal server2
    
 }//Fine copyDatabase()
 
 public synchronized void copyDataFile(){
    
  String inputLine,settore,fila,posto,nome;
  int d,i,j,n;
  
  try{
     FileReader inFile=new FileReader(DATAFILE);
     LineNumberReader inLines= new LineNumberReader(inFile);
     while((inputLine=inLines.readLine())!=null) {//Ciclo sul file
        d=inputLine.indexOf('.');
        i=inputLine.indexOf('-');
        j=inputLine.indexOf(' ');
        n=inputLine.length(); 
        nome=inputLine.substring(j+1,n);
        settore=inputLine.substring(0,d);
        fila=inputLine.substring(d+1,i);
        posto=inputLine.substring(i+1,j);
        setName(settore,fila,posto,nome);
     }
     
    inFile.close();
    
 }catch(IOException ex){;}

}//Fine copyDataFile
 
 //Copia le informazioni sui dati in un vettore
  public synchronized Vector dumpDataFile(){
      
   while(DBFREE!=true){;}
   
   DBFREE=false;
   
   Vector copy=new Vector();
   int dim=database.size();      
   for(int i=0;i<dim;++i){
      Ticket biglietto=(Ticket) database.elementAt(i);
      if((biglietto.modo).equals("F")){//se il posto  stato venduto
         String s=(String)(biglietto.settore)+"."+(String)(biglietto.fila)+"-"+(String)(biglietto.posto)+" "+(String)(biglietto.nome);
         copy.addElement(s);
       }
     }
     
   DBFREE=true;
   
   return copy;
     
 }//Fine dumpDataFile
  
  
//Copia il database
 public synchronized Vector dumpDB() {

   while(DBFREE!=true){;}
   
   DBFREE=false;
   
   Vector copy=new Vector();
   int dim=database.size();
   String line=getPrices();
   String settCorr="X";
   Ticket biglietto;
   
   copy.addElement(line);
   
   for(int i=0;i<dim;++i){
   
        biglietto=(Ticket) database.elementAt(i);
        if(!((biglietto.settore).equals(settCorr))){//se ho cambiato settore
              addSectorLine(copy,(String) biglietto.settore);//scriva la stringa del settore
              settCorr=(String)biglietto.settore;
          }
         line=(String)biglietto.fila+"-"+(String)biglietto.posto+" "+(String)biglietto.modo;
         copy.addElement(line);
 }
   
   DBFREE=true;
   
   return copy;
   
}//fine dumpDB()


private void addSectorLine(Vector copy, String settore){

    int nfile=getRowsNumber(settore);
    int nposti=getSeatsNumber(settore);
    String line="SETTORE "+settore+" POSTI "+nposti+" FILE "+nfile;
    copy.addElement(line);

}//Fine addSectorLine


public synchronized int incasso(){
   
   String infoPrezzi=getPrices();
   int index=0;
   String p;
   
   int n=infoPrezzi.length();
   int x=infoPrezzi.indexOf(' ');    
   String s=infoPrezzi.substring(x+1,n);
   int money=0;
   
    //String costi []=new String[8];//Crea l'array dei prezzi 
    int costi []=new int[8];//Crea l'array dei prezzi 
    for(int i=0;i<7;++i) {
         n=s.length();
         x=s.indexOf(' ');
         costi[i]=Integer.parseInt(s.substring(0,x));
         s=s.substring(x+1,n);
         }
     costi[7]=Integer.parseInt(s);   
     int dim=database.size();
     String settore="A";
     index=0;
     
     for(int j=0;j<dim;++j){//ciclo su tutto il database
        
        Ticket y=(Ticket) database.elementAt(j);
        if(!(settore.equals(y.settore))){//se ho cambiato di settore, aggiorno i dati
           settore=y.settore;
           index=index+1;
        }
        if((y.modo).equals("F")){//se il posto  stato venduto
           money=money+costi[index];
        }
      }
    return money;

}//Fine incasso() 
 
 public synchronized Vector postiFree(){
   
   Vector posti=new Vector();
   String s=null;
   int dim=database.size();
   int postiTot=0;
   for(int i=0;i<dim;++i){
      Ticket x=(Ticket) database.elementAt(i);
      if((x.modo).equals("E")){
         ++postiTot;
         s=(String)x.settore+":"+(String)x.fila+"-"+(String)x.posto;
      }
    }
    String totPosti=Integer.toString(postiTot);
    posti.addElement(totPosti);
      
      return posti;
       
 }//Fine postiFree();
 
  public synchronized boolean checkDB() {  
     return DBFREE;
 }
  
//Metodi per la variabile di COMMIT
 public synchronized void updateCOMMIT(){
     COMMIT=COMMIT+1;
   }
 
 public synchronized int readCOMMIT() {  
     return COMMIT;
 }
 
 public synchronized void resetCOMMIT() {
    COMMIT=0;
   }
 
 
 //Setta lo stato della variabile di database
 public synchronized void setInfo(String line){
     INFO=line;
 } 

 //Usata per ricavare i prezzi dal database  
public synchronized String getPrices(){//processo LETTORE della riga di INFO del database LOGICO
   
   String prezzi=INFO;
   return prezzi;
       
 }//fine getPrices()

//Restituisce il numero delle file per il settore richiesto o 0 se il settore  errato
private int getRowsNumber(String lettera){
    
    String numero=null;
    int dim=database.size();
    Ticket abbonamento;
    int nfile=0;
    
    for(int i=0;i<dim;++i){//Ciclo sul vettore di database alla ricera del settore 
            abbonamento=(Ticket) database.elementAt(i);
            if((abbonamento.settore).equals(lettera)){//se si tratta del settore che cerco
                  numero=(String)abbonamento.fila;
             }    
            else{//se non  il settore che cerco
                if(numero!=null) break; //e l'ho gi trovato esco dal ciclo
            }
   }       
    
    if(numero!=null){
           nfile=Integer.valueOf(numero).intValue();
    }
    
    else nfile=0;
    return nfile; 

}//Fine getRowsNumber


//Usata per ricavare il numero dei posti
private int getSeatsNumber(String lettera){
   
   int nfile=getRowsNumber(lettera);
   int nposti=nfile*10;
   return nposti;
   
}//Fine getSeatsNumber


//Usata per ricavare la mappa=>restituisce la stringa "" in caso di errore
 public synchronized String getMap(String settore){//processo LETTORE del database LOGICO
    
    String answer="";
    int dim=database.size();
    String linea="";
    Ticket abbonamento;
    
    for(int i=0;i<dim;++i){//Ciclo sul vettore di database alla ricera del settore 
            abbonamento=(Ticket) database.elementAt(i);
            if((abbonamento.settore).equals(settore)){//se si tratta del settore che cerco
                       String map=mapping(i,settore);//processo la mappa del settore
                       answer=map;//ritorno la mappa
                       break;//e esco dal ciclo
               }    
          }       

    return answer; 
     
 } //Fine getMap()
   

//Crea la mappa del settore
 private String mapping(int i,String settore){
   
   Ticket abbonamento;
   String map="";
   int dim=database.size();
   for(int k=i;k<dim;++k){
             
             abbonamento=(Ticket) database.elementAt(k);
             
             if((abbonamento.settore).equals(settore)){//finch siamo nel settore richiesto
      
               String fila=abbonamento.fila;
               int nfila=(new Integer(Integer.parseInt(fila,10))).intValue();
           
               String posto=abbonamento.posto;
               int nposto=(new Integer(Integer.parseInt(posto,10))).intValue();
            
               String modo=abbonamento.modo;
               if(nposto==10) map=map+modo+"-";//le file sono di 10 posti, quando ho letto 10 variabili di stato aggiungo -
               else map=map+modo;
         }
         else break;//Ho finito lo scan del settore
       } 
  return map;
   
   }// Fine mapping()

/*Cerca e setta P il posto richiesto
Ritorna:
NO in caso di posto F o assenza del posto richiesto
OK se il posto  E ed  stato prenotato
OCC se  gi P
*/
public synchronized String readAndUpdateDB(String settore,String fila,String posto){
   
   Ticket abbonamento;
   String stato="";
   
   int dim=database.size();
   for(int i=0;i<dim;++i){
      abbonamento=(Ticket) database.elementAt(i);
      if((abbonamento.settore).equals(settore)){//se  il settore che cerchiamo
          if(((abbonamento.posto).equals(posto))&& ((abbonamento.fila).equals(fila))){//e il posto che cerchiamo
                   if((abbonamento.modo).equals("E")) {//ed  libero
                       stato="OK";//settiamo la variabile di stato per il ritorno e
                       abbonamento.modo="P";//lo blocchiamo!
                       Date today=new Date();
                       abbonamento.dataPrenotaz=new GregorianCalendar();
                       (abbonamento.dataPrenotaz).setTime(today);
                       break;
                    }
                 if((abbonamento.modo).equals("F")) stato="NO";
                 if((abbonamento.modo).equals("P")) stato="OCC";
           }
       }
      else stato="NO";
   }//fine ciclo for
   
  return stato;
         

}//fine readAndUpdateDB()

   
  public synchronized String checkPlace(String settore,String fila,String posto){
  
     Ticket abbonamento;
     String stato="";
   
     int dim=database.size();
      for(int i=0;i<dim;++i){
         abbonamento=(Ticket) database.elementAt(i);
         if((abbonamento.settore).equals(settore)){//se  il settore che cerchiamo
            if(((abbonamento.posto).equals(posto))&& ((abbonamento.fila).equals(fila)))//e il posto che cerchiamo
               {stato=abbonamento.modo;
                 break;}
          }
       }
     return stato;
  
  }//Fine checkPlace
   
public synchronized GregorianCalendar getDataPrenotaz(String settore,String fila,String posto){
    Ticket abbonamento;
    GregorianCalendar data=null;
   
   int dim=database.size();
   for(int i=0;i<dim;++i){
      abbonamento=(Ticket) database.elementAt(i);
      if((abbonamento.settore).equals(settore)){//se  il settore che cerchiamo
          if(((abbonamento.posto).equals(posto))&& ((abbonamento.fila).equals(fila))){//e il posto che cerchiamo
               data=abbonamento.dataPrenotaz;
               break;
          }
      }
   }

return data;

}//Fine getDataPrenotaz();


//Usata per cambiare lo stato del posto
public synchronized void setTicket(String settore,String fila,String posto,String status){
    
    int dim=database.size();
   for(int i=0;i<dim;++i){
      abbonamento=(Ticket) database.elementAt(i);
      if((abbonamento.settore).equals(settore)){//se  il settore che cerchiamo
          if(((abbonamento.posto).equals(posto))&& ((abbonamento.fila).equals(fila))){//e il posto che cerchiamo
              abbonamento.modo=status;
              if(status.equals("E")) abbonamento.dataPrenotaz=null;
              break;
         }
      }  
   }   

}//Fine setTicket()
 
 public synchronized void setName(String settore,String fila,String posto,String name){
    
    int dim=database.size();
   for(int i=0;i<dim;++i){
      abbonamento=(Ticket) database.elementAt(i);
      if((abbonamento.settore).equals(settore)){//se  il settore che cerchiamo
          if(((abbonamento.posto).equals(posto))&& ((abbonamento.fila).equals(fila))){//e il posto che cerchiamo
              abbonamento.nome=name;
              break;
         }
      }  
   }   


 }//Fine setName
 
 //Aggiorna il DB fisico
 public synchronized void aggiornaDB(){
     
   FileOutputStream dbFile=null;
   int dim=database.size();
   String settCorr="X";
   Ticket biglietto;
   String line=null;
   
  try{
         dbFile=new FileOutputStream("database.txt");
  }catch(IOException ex){;//CHE FARE SE VA MALE???
           }
   
 save(INFO,dbFile);
      
  for(int i=0;i<dim;++i){//Ciclo su tutto il DB logico
      
          biglietto=(Ticket) database.elementAt(i);
          if(!((biglietto.settore).equals(settCorr))){//se ho cambiato settore
              writeSectorInfo(dbFile,(String) biglietto.settore);//scriva la stringa del settore
              settCorr=(String)biglietto.settore;
          }
          line=(String)biglietto.fila+"-"+(String)biglietto.posto+" "+(String)biglietto.modo;
          save(line,dbFile);
 }
      
  try{
     dbFile.close();  
  }catch(IOException ex) {;//CHE FARE SE VA MALE???
      }
   
   
 }//fine aggiornaDB();
 
//Usata per aggiornare l'elenco anagrafico dei posti con i nomi
 public synchronized void aggiornaDati(){
     
   FileOutputStream dataFile=null;
   int dim=database.size();
   String settCorr="X";
   Ticket x;
   String line=null;
   
  try{
         dataFile=new FileOutputStream("dati.txt");
  }catch(IOException ex){;//CHE FARE SE VA MALE???
           }
   
   
  for(int i=0;i<dim;++i){//Ciclo su tutto il DB logico
  
     x=(Ticket)database.elementAt(i);
     if(((String)(x.modo)).equals("F")){//se il posto  fissato
         String nome=(String) x.nome;
         line=(String)x.settore+"."+(String)x.fila+"-"+(String)x.posto+" "+nome;
         save(line,dataFile);
     }
  
  }   
   
  try{
     dataFile.close();  
  }catch(IOException ex) {;//CHE FARE SE VA MALE???
      }
 
 }//Fine aggiornaDati
 
 //Crea la stringa di info sul settore
 private void writeSectorInfo(FileOutputStream dbFile, String settore){
  
    int nfile=getRowsNumber(settore);
    int nposti=getSeatsNumber(settore);
    String line="SETTORE "+settore+" POSTI "+nposti+" FILE "+nfile;
    save(line,dbFile);
 
 }//Fine writeSectorInfo
 
 //Salva le linee sul file creato            
  private void save(String text, FileOutputStream dbFile) {
  
     text=text+"\n";
     try{
     
       for(int k=0;k<text.length();++k) {
                  dbFile.write(text.charAt(k));
       }
       
   }catch(IOException ex) {System.out.println("Errore nella scrittura del database");}        
  
  }//Fine save();       
  
   
}//fine classe Database