/*Da implementare 
1. TUTTI i messaggi di errore!!!!
2. Il server deve tenere conto degli user+pwd dei client che accedono in quel momento per prevenire accessi multipli 
4. Se chiudo il thread dopo una non autenticazione, si chiude anche l'applicazione client......
6. Implementare la possibilit di far cadere la connessione se un client non risponde 
    (su Ricevuta richiesta per settore....null)
7. fare attenzione ai casi in cui si verifica NullPointerException su caduta del client da "catchare"
*/

import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.ProgressMonitor;
import java.net.*;
import java.util.*;
import java.util.GregorianCalendar;
import java.util.Random;

public  class ServerApp extends JFrame{

           int LUNG=400;
            int LARG=400;
            
            JTextArea areaTesto=new JTextArea();
            JButton server=new JButton("SERVER");
            JButton incasso=new JButton("INCASSO");
            JButton postiFree=new JButton("POSTI LIBERI");
            JButton quit=new JButton("QUIT");
            JScrollPane scroll=new JScrollPane(areaTesto);
            
            String server2="localhost";
            int server2Port=1235;
            Database database;
            GestoreTransazione transazione;
            updateObj aggiornamento;
          
 public static void main(String args[]){
 
      ServerApp server=new ServerApp();
      server.run();

 }
 
           
 // Costruttore           
  public ServerApp() {
    
            super("SERVER");
            setSize(LUNG,LARG);
            setLocation(100,100);
            buildGUI();
            show();
            
 }//Fine costruttore
     
               
// Costruzione della parte grafica
 void buildGUI() {
         
          getContentPane().setLayout(null);
          scroll.setBounds(30,30,300,250);
          addButton(database);
          getContentPane().add(scroll);
          scroll.setBorder(new BevelBorder(BevelBorder.LOWERED));

 }//Fine buildGUI
 
 void addButton(Database database){
    
    incasso.setBounds(30,300,120,35);
    server.setBounds(190,300,120,35);
    postiFree.setBounds(30,345,120,35);
    quit.setBounds(190,345,120,35);
    
    incasso.addActionListener(new ButtonHandler(database));
    server.addActionListener(new ButtonHandler(database));
    postiFree.addActionListener(new ButtonHandler(database));
    quit.addActionListener(new ButtonHandler(database));
    
    getContentPane().add(incasso);
    getContentPane().add(server);
    getContentPane().add(quit);
    getContentPane().add(postiFree);

 
 }//Fine addButton
 
 
 void tryUpdate(){

  if((aggiornamento.getUPD())!=0){//se ho un DB inconsistente
     boolean DBUpdate=aggiornamento.update(database);//verifico se ho aggiornato il DB logico
     if(DBUpdate==true){//se ho aggiornato
        database.aggiornaDB();//salvo l'aggiornamento su DBFISICO
     }
     aggiornamento.checkLost();//verifico eventuali posti da non ricercare di nuovo
}


}//Fine tryUpdate

            
   public void run() {
        
        serverInit init=new serverInit();
        init.initServer();
        server2=init.getServer2();
        server2Port=init.getServer2Port();
        String address=init.getServer();
        String bankServer=init.getBankServer();
        int bankServerPort=init.getBankServerPort();
        int port=init.getPort();
        
        aggiornamento=new updateObj(server2,server2Port);
        database=new Database(aggiornamento);
        tryUpdate();
        
        addButton(database);
        try {
                ServerSocket server=new ServerSocket(port);
                int localport=server.getLocalPort();
                areaTesto.append("\nIn ascolto sulla porta "+localport);
                int i=0;
                do{
                    Socket client=server.accept();
                    i++;
                    (new ServerThread(aggiornamento,client,areaTesto,i,database,server2,server2Port,transazione,bankServer,bankServerPort)).start();
                }while(true);
            }catch(IOException ex) {System.out.println("Errore");
                     System.exit(0);}
        }
       
       
       
  // Classe che gestisce i bottoni del server
  class ButtonHandler implements ActionListener{
          Database database;
          
          ButtonHandler(Database mioDB){
            database=mioDB;
          }
       
    public void actionPerformed(ActionEvent e) {
            String s=e.getActionCommand();
            if(s.equalsIgnoreCase("INCASSO")) {//ricavo l'incasso dal metodo del database
               try{
                int money=database.incasso();
                ServerMessage x=new ServerMessage("INCASSO  "+money);
              }catch(NullPointerException ex) {;}
            }
            
            if(s.equalsIgnoreCase("SERVER")) {//pannello di preferenze
                setPreferences w=new setPreferences();
            }
            
            if(s.equalsIgnoreCase("POSTI LIBERI")) {//ricavo i posti liberi dal metodo del database
             try{
                 Vector posti=database.postiFree();//il vettore contiene il numero dei posti liberi e tutti i posti
                int dim=posti.size();
                String numPosti=(String) posti.elementAt(dim-1);
                ServerMessage y=new ServerMessage("POSTI LIBERI: "+numPosti);
              }catch(NullPointerException ex) {;}
            }
            if(s.equalsIgnoreCase("QUIT")) {//esco dal sistema
              System.exit(0);
            }
   }
         
  }//Fine ButtonHandler
       
       
       
   }//Fine classe ServerApp          
   
   
  class ServerThread extends Thread {
       Socket client,connection;
       BufferedReader inStream;
       DataOutputStream outStream;
       FileReader inFile;
       String inLine,server2,bankServer;
       JTextArea areaTesto;
       int num,server2Port,bankServerPort;
       boolean DBFREE=true;
       Database database;
       GestoreTransazione transazione;
       updateObj aggiornamento;
       
       //Costruttore del thread
       public ServerThread(updateObj aggiornamento,Socket client,JTextArea areaTesto,int num,Database database,String server2,int server2Port,GestoreTransazione transazione,String bankServer,int bankServerPort) {
         this.num=num;
         this.client=client;
         this.areaTesto=areaTesto;
         this.database=database;
         this.server2=server2;
         this.server2Port=server2Port;
         this.transazione=transazione;
         this.bankServer=bankServer;
         this.bankServerPort=bankServerPort;
         this.aggiornamento=aggiornamento;

       }
           
  //Inizio vero e proprio del thread         
    public void run(){   
         try{
                String destname=client.getInetAddress().getHostName();
                int destport=client.getPort();
                areaTesto.append("\nConnessione n "+num);
                areaTesto.append("\nAccettata a "+destname+" sulla porta "+destport); 
                
                 inStream=new BufferedReader(new InputStreamReader(client.getInputStream()));
                 outStream=new DataOutputStream(client.getOutputStream());
                 
                 String message=receiveMessage();
                 processRequest(message);      
                
              }catch(IOException ex) {System.out.println("Errore");}  
              
           }
   
   //Processa il primo messaggio arrivato al thread e verifica il tipo di accesso richiesto   
    void processRequest(String message) {
    
       if(message.equalsIgnoreCase("AC")) {areaTesto.append("\nRicevuta richiesta di accesso");
           clientRequest();}
       
       if(message.equalsIgnoreCase("AS")) {areaTesto.append("\nRicevuta richiesta da un server");
           serverRequest();}
        
        if ((!(message.equalsIgnoreCase("AS"))) && (!(message.equalsIgnoreCase("AC")))) closeConnection();
           
     }//Fine processRequest()
   
   
   //Gestisce l'accesso da parte dei client      
   void clientRequest(){
         
            int c=sendMessage("OK");//Spedisce messaggio di attesa di user+pwd dal client
                 
            if(c!=0){//Messaggio di attesa della user+pwd ricevuto dal client
                   int res=passwordCheck();//Verifico i privilegi del cliente 
                   if (res==1) sendPrices();//Se pu accedere gli spedisco i prezzi dei settori
                   if (res==0) {
                         closeConnection();
                   }
             }
                   
             else {//Messaggio di attesa della user+pwd NON ricevuto dal client
                    closeConnection();
             }  
                
                
  }//Fine clientRequest
          
  
  /*Gestisce la verifica della password
  Ritorna 
  1 se accesso consentito
  0 se accesso negato o se ci sono problemi di collegamento
  */
  int passwordCheck(){
       
                   String user=receiveMessage();
                   String pass=receiveMessage();
                   if((user==null)||(pass==null)) {//se uno dei due  un CRASH
                        closeConnection();
                   }
                   
                   boolean check=search(user,pass);
                   
                   if (check) {//Accesso consentito
                      int c=sendMessage("OK");//lo comunico al client
                      if( c!=0) {areaTesto.append("\nConsentito accesso al client "+user);
                                       return 1;}
                                       
                       else {//se ho problemi sulla send
                          return 0;
                        }
                       
                   }   
                                  
                  else {//Accesso negato
                     areaTesto.append("\nAccesso negato.");
                     int c=sendMessage("NO");//lo comunico al client
                     return 0;           
                  }
                   
  }//Fine passwordCheck()
 
 
 //Spedisce i prezzi dei settori al client: in mutua esclusione per evitare che un processo 
 //che aggiorna il database scriva mentre io leggo i prezzi
   public void sendPrices() {
 
     areaTesto.append("\nAttendo il client");
     String message=receiveMessage();//Attendo la comunicazione che il server sia pronto
     
     if(message.equalsIgnoreCase("RDY")){//Se ricevo il giusto messaggio prelevo dal database  i prezzi
         
         String prezzi=database.getPrices();
         int ans=sendMessage(prezzi);//e li invio al client 
         if(ans==1) mapRequest();
         else closeConnection();
     }
     
     else {//Ricevuto un messaggio che non ritengo valido
        closeConnection();
     }
     
  }
  
  
 //Soddisfa la richiesta di mappa del cliente
  void mapRequest() {
     
       String settore=receiveMessage();
       if(settore==null) closeConnection();
       
       areaTesto.append("\nRicevuta richiesta per settore "+settore);
       settore=settore.trim();//elimino eventuali spazi aggiunti alla stringa dal client
       
       String map=database.getMap(settore);
      //Controlli sulla stringa ricevuta 
       if(map.equals("")){
                areaTesto.append("\nErrore nella richiesta del settore!!!");
                closeConnection();
       }
       
         else{//se ho ottenuto una mappa valida
                 areaTesto.append("\nSpedisco la mappa al cliente");
                 int ans=sendMessage(map);//la spedisco al client
                 if(ans!=0) verificaPosto(settore);
                 else closeConnection();//in caso di errore sulla spedizione chiudo
                 
         }                   
     
    }//fine mapRequest();
     

 //Usata per verificare il posto richiesto e inizializzare il collegamento remoto con l'altServer
 void verificaPosto(String lettera) {
        
        BufferedReader inServerStream=null;
        DataOutputStream outServerStream=null;
        int pos=0;
        int space=0;
        int n=0;    
        
        areaTesto.append("\nAttendo client");
        String message=receiveMessage();
        if (message==null) closeConnection(); //Se non ho un messaggio chiudo
        else{
          String settore=lettera.trim();
          int x=message.length();
          int y=message.indexOf('-');
          String fila=message.substring(0,y);
          String posto=message.substring(y+1,x);
          areaTesto.append("\nVerifico posto "+posto+"\nnel settore "+settore+"\nfila "+fila);
        
           int oldPriority=getPriority();
          setPriority(MAX_PRIORITY);//setto al massimo la priorit del thread durante questa operazione
          
          String libero=database.readAndUpdateDB(settore,fila,posto);
          if(libero.equalsIgnoreCase("OK")){//Il posto  libero
          	areaTesto.append("\nIl posto: sett. "+settore+" Fila "+fila+" Posto "+posto+
                    							 "E' libero\nVerifico sull'altro server");
                    							 
                    							 
        //Creo la connessione con l'altro server(se va male tento DUE VOLTE)
        try{
            
             connection=new Socket(server2,server2Port);
         
        }catch(UnknownHostException ex) {//se  un server sconosciuto  1 TENTATIVO
        
        
        
                try{//riprovo una seconda volta
           
                     connection=new Socket(server2,server2Port); 
                
               }catch(UnknownHostException uhe) {//server sconosciuto2 TENTATIVO
         					areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
         					//Non c' conferma dall'altro server sulla natura del posto=>Lo considero libero
         					GestoreTransazione transazione=null;
                                                int ans=sendMessage("PAY");
                                                payTicket(settore,fila,posto,transazione);
                                            }
               catch(IOException ie) {  //errore in I/O 2 TENTATIVO
               					       areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
                                                      //Non c' conferma dall'altro server sulla natura del posto=>Lo considero libero
                                                      GestoreTransazione transazione=null;
                                                      int ans=sendMessage("PAY");
                                                      payTicket(settore,fila,posto,transazione);
                                                      }
                                                      
                                                      
          }//Fine catch della Unknown Host ex
          
         catch(IOException ex) {//errore in I/O    1 TENTATIVO
         
         
                try{//riprovo una seconda volta
           
                     connection=new Socket(server2,server2Port); 
                
               }catch(UnknownHostException uhe) {//server sconosciuto2 TENTATIVO
         					areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
         					//Non c' conferma dall'altro server sulla natura del posto=>Lo considero libero
         					GestoreTransazione transazione=null;
                                                int ans=sendMessage("PAY");
                                                payTicket(settore,fila,posto,transazione);
                                            }
               catch(IOException ie) {  //errore in I/O 2 TENTATIVO
               					       areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
                                                      //Non c' conferma dall'altro server sulla natura del posto=>Lo considero libero
                                                      GestoreTransazione transazione=null;
                                                      int ans=sendMessage("PAY");
                                                      payTicket(settore,fila,posto,transazione);
                                                      }
                                                      
                                                      
           }//Fine catch della IOEx
           
           
         //se il server c' creo i flussi per la comunicazione
         try{
         
               inServerStream=new BufferedReader(new InputStreamReader(connection.getInputStream()));
               outServerStream=new DataOutputStream(connection.getOutputStream());
                
         }catch(IOException ex){//un eccezione qui impedisce di avere l'altro server. Agisco come se fossi solo
                areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
                 //Non c' conferma dall'altro server sulla natura del posto=>Lo considero libero
                 GestoreTransazione transazione=null;
                 int ans=sendMessage("PAY");
                 payTicket(settore,fila,posto,transazione);
          }
          
         //Se ho evitato tutti i problemi.....creo il gestore della transazione corrente
         GestoreTransazione transazione=new GestoreTransazione(connection,inServerStream,outServerStream);
         				 
           message=infoAltServer(settore,posto,fila,transazione);//verifico sull'altro server
           if(message.equalsIgnoreCase("OK")){//Ɏ libero anche di l
               int ans=sendMessage("PAY");//mando comunicazione di pagamento
               if(ans==1) payTicket(settore,fila,posto,transazione);
               else {//problema di comunicazione con il client
                   transazione.abortMethod();//comunico all'altro server che tutto  saltato
                   database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
                   closeConnection();//e chiudo la connessione
              }
           }
            if(message.equalsIgnoreCase("NO")){//il posto  occupato sull'altro server
               areaTesto.append("\nIl posto  occupato");
               int ans=sendMessage("NO"); //spedisco al client l'annullamento del posto
               closeConnection();
            }
                   			
        }//Fine -il posto  libero-
            
          else {//Il posto non  libero
                   areaTesto.append("\nIl posto  occupato");
                    int ans=sendMessage("NO"); //spedisco al client l'annullamento del posto
                    closeConnection();
                   }
           
          
        } 
        
   }//Fine verificaPosto() 
   
   
  /*Usata per determinare le informazioni sul posto nell'altro server
  Ritorna
  OK se il posto  mio o se l'altro server si  disconnesso
  NO se il posto  dell'altro server
   */
  String infoAltServer(String settore, String posto, String fila,GestoreTransazione transazione) {
     
         int ans=transazione.connect();//lo faccio connettere all'altro server secondo il protocollo usuale
         if(ans==0){
         		   areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
         		    return "OK";//se non ho risposta dall'altro server mi ritengo solo
         		    }
         		    
        String message=transazione.checkPlace(settore,fila,posto);//e gli chiedo di verificare sull'altro server il posto richiesto
        
        if(message.equalsIgnoreCase("ERR")){areaTesto.append("\nConnessione all'altro server: Il server NON risponde...sono solo???");
         		    			return "OK";}//se  c' un errore sulla connessione con l'altro server considero il posto FREE
         		    			
         									
         if(message.equalsIgnoreCase("OCC")){//se  occupato gestisco la priorit dell'accesso
                     GregorianCalendar dataPrenotaz=database.getDataPrenotaz(settore,fila,posto);
                     ans=transazione.setPriority(dataPrenotaz); 
                     if(ans==0) return "NO";
                     if(ans==1) return "OK";
        }
       if(message.equalsIgnoreCase("NO")){//il posto  FULL sull'altro server						
          database.setTicket(settore,fila,posto,"F");
          return "NO";
       }
       if(message.equalsIgnoreCase("OK")){//il posto  EMPTY sull'altro server
          return "OK";
       }
    
    return "NO";
     
  }//Fine infoAltServer()   
  
 
//Usata per comunicare al client la necessit di un pagamento 
void payTicket(String settore,String fila,String posto,GestoreTransazione transazione) {

int ans;
String message=receiveMessage();
if(message==null) {//Il cliente  crashato
          transazione.abortMethod();//comunico all'altro server che tutto  saltato
          database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
          closeConnection();//e chiudo la connessione
}


//*********CASO DI PAGAMENTO CASH**************


if(message.startsWith("CASH")) {//Il cliente ha pagato CASH al botteghino

  int d=message.indexOf('.');//ricavo nome e cognome
  int i=message.indexOf('#');
  int j=message.length();
  String nome=message.substring(d+1,i);
  String cognome=message.substring(i+1,j);
  
  if(transazione!=null){//Se l'altServer esiste
     areaTesto.append("\nRicevuta conferma di pagamentocomunico all'altro server");   
     String dati=nome+" "+cognome;
     ans=transazione.payMethod(dati);
   }
   else ans=1;//altrimenti simulo di avere avuto una risposta dall'altServer
   
  if(ans==1) {//se ho confermato sull'altServer
         areaTesto.append("Posto confermato sull'altServer");
         database.setTicket(settore,fila,posto,"F");//blocco il posto
         database.setName(settore,fila,posto,nome+" "+cognome);
         areaTesto.append("Spedisco OK al cliente");
         int risp=sendMessage("OK");//mando conferma al client
         
         if(risp==1){//se il messaggio  partito
            message=receiveMessage();//attendo la conferma del client
            if(message.equalsIgnoreCase("TERM")) {//se  positiva
               if (transazione!=null)transazione.confirmMethod();
               fineTransazione();//e chiudo la transazione
            }
            if((message.equalsIgnoreCase("ABT"))||(message==null)) {//se il cliente  crashato senza conferma
                 transazione.abortMethod();//comunico all'altro server che tutto  saltato
                 database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
                 closeConnection();//e chiudo la connessione
           }
        }
        
       else{//il messaggio non  partito, nessuna conferma al client
            transazione.abortMethod();//comunico all'altro server che tutto  saltato
            database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
            closeConnection();//e chiudo la connessione
       }
   }
   
  else{ //se l'altServer non riceve il messaggio o ci sono problemi, penso sia caduto e confermo lo stesso!!!!ma non ho pi la transazione      
         areaTesto.append("L'altServer non risponde..mi arrangio");
         database.setTicket(settore,fila,posto,"F");//blocco il posto
         database.setName(settore,fila,posto,nome+" "+cognome);
         areaTesto.append("\nSpedisco OK al cliente");
         int risp=sendMessage("OK");//mando conferma al client
         
         if(risp==1){//se il messaggio  partito
            message=receiveMessage();//attendo la conferma del client
            if(message.equalsIgnoreCase("TERM")) {//se  positiva
               fineTransazione();//e chiudo la transazione
            }
            if((message.equalsIgnoreCase("ABT"))||(message==null)) {//se il cliente  crashato senza conferma
                 database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
                 closeConnection();//e chiudo la connessione
           }
        }
        
       else{//il messaggio non  partito, nessuna conferma al client
            database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
            closeConnection();//e chiudo la connessione
       }
       
  }
}//Fine Caso CASH


//******CASO DI PAGAMENTO CON CREDIT CARD***************

if (message.startsWith("CC")){//Il cliente richiede l'addebito su carta di credito
   
     BankAccess pagamento=new BankAccess();
    
     int i=message.indexOf('#');//ricavo nome e cognome
     int j=message.indexOf('$');
     int k=message.indexOf('@');
     String nome=message.substring(i+1,j);
     String cognome=message.substring(j+1,k);
     
     int ret=creditCard(message,settore,pagamento);//chiamo il metodo che gestisce la transazione sul bank server
     
   if(ret==1) {//se la risposta  positivaCASO 1
      if(transazione!=null){//Se l'altServer esiste    
        areaTesto.append("\nRicevuta conferma di pagamentocomunico all'altro server");   
        String dati=nome+" "+cognome;
        ans=transazione.payMethod(dati);
      }
      else ans=1;//altrimenti simulo di avere avuto una risposta dall'altServer
   
      if(ans==1) {//se ho confermato sull'altServer
            database.setTicket(settore,fila,posto,"F");//blocco il posto
            database.setName(settore,fila,posto,nome+" "+cognome);
 	    areaTesto.append("\nSpedisco OK al cliente");
 	    int risp=sendMessage("OK");//mando conferma al client
 	    
 	    if(risp==1){//se il messaggio  partito
 	      pagamento.conferma();
              message=receiveMessage();//attendo la conferma del client
              if(message.equalsIgnoreCase("TERM")) {//se  positiva
              pagamento.chiudiTransazione();
               if (transazione!=null)transazione.confirmMethod();
                 fineTransazione();//e chiudo la transazione
              }
              if((message.equalsIgnoreCase("ABT"))||(message==null)) {//se il cliente  crashato senza conferma
                 transazione.abortMethod();//comunico all'altro server che tutto  saltato
                 pagamento.abortMethod();
                 database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
                 closeConnection();//e chiudo la connessione
            }
        }
            else{//il messaggio non  partito, nessuna conferma al client
                transazione.abortMethod();//comunico all'altro server che tutto  saltato
                pagamento.abortMethod();
                database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
                closeConnection();//e chiudo la connessione
            }
       }
       
         else{ //se l'altServer non riceve il messaggio o ci sono problemi, penso sia caduto e confermo lo stesso!!!!ma non ho pi la transazione      
           database.setTicket(settore,fila,posto,"F");//blocco il posto
           database.setName(settore,fila,posto,nome+" "+cognome);
           areaTesto.append("\nSpedisco OK al cliente");
           int risp=sendMessage("OK");//mando conferma al client
         
         if(risp==1){//se il messaggio  partito
            pagamento.conferma();
            message=receiveMessage();//attendo la conferma del client
            if(message.equalsIgnoreCase("TERM")) {//se  positiva
               pagamento.chiudiTransazione();
               fineTransazione();//e chiudo la transazione
            }
            if((message.equalsIgnoreCase("ABT"))||(message==null)) {//se il cliente  crashato senza conferma
                 database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
                 pagamento.abortMethod();
                 closeConnection();//e chiudo la connessione
           }
        }
        
       else{//il messaggio non  partito, nessuna conferma al client
            database.setTicket(settore,fila,posto,"E");//ripristino lo stato del posto
            pagamento.abortMethod();
            closeConnection();//e chiudo la connessione
         }
      }
   
  }//Fine CASO 1   
     
     
     if(ret==-1){//se il conto  insufficienteCASO 2
            int risp=sendMessage("INS");//mando conferma al client
            payTicket(settore,fila,posto,transazione);//e ripeto il metodo in attesa di una sua decisione
     }//Fine CASO 2
     
     if(ret==0){//se il conto non esisteCASO 3
            int risp=sendMessage("NO");//mando conferma al client
            payTicket(settore,fila,posto,transazione);//e ripeto il metodo in attesa di una sua decisione
     }//Fine CASO 3
     
}//Fine caso CC

}//Fine payTicket();


/*Gestisce la transazione via credit card 
Ritorna
1 se il pagamento  OK
0 o -1 se il pagamento non  stato effettuato
*/
int creditCard(String message,String settore,BankAccess pagamento){

   int ans=pagamento.connetti(bankServer,bankServerPort);
   String costi=database.getPrices();
   String prezzo=ricavaPrezzo(costi,settore);
   ans=pagamento.preleva(message,prezzo);
   if(ans==1){//pagamento effettuato
       return 1;
   }
   if(ans==0){//pagamento NON effettuato
       return 0;
   }
   if(ans==-1){//pagamento NON effettuato
       return -1;
   }

return 0;
}//Fine creditCard 
       
//Usata per ricavare il costo del settore
String ricavaPrezzo(String infoPrezzi,String settore){
    
   String [] settori={"A","B","C","D","E","F","G","H"};
   int index=0;
   String p;
   
   int n=infoPrezzi.length();
   int x=infoPrezzi.indexOf(' ');    
   String s=infoPrezzi.substring(x+1,n);
   
    String costi []=new String[8];//Crea l'array dei prezzi 
    
    for(int i=0;i<7;++i) {
         n=s.length();
         x=s.indexOf(' ');
         costi[i]=s.substring(0,x);
         s=s.substring(x+1,n);
         }
     costi[7]=s;   
     
     for(int i=0;i<8;++i){
        if(settori[i].equalsIgnoreCase(settore)) index=i;
      }
     p=costi[index];
     return p;

}//Fine ricavaPrezzo    
       
       
//Usata per verificare le password        
      boolean search(String user,String pass) {
         
         try{
           
                  FileReader inFile=new FileReader("access.txt");
                  LineNumberReader inLines= new LineNumberReader(inFile);
                  String inputLine;
                  areaTesto.append("\nVerifico accesso...");
                  while ((inputLine=inLines.readLine()) != null) {
                      int ac=accesso(inputLine,user,pass);     
                      if(ac==1) return true;
                     }
                 }catch (IOException ex) {System.out.println("ERRORE");}
      return false;
      
      }//Fine search();
  
  //Effettua la verifica vera  e propria della pass      
    int accesso(String linea,String user,String pass) {
        
          int x=linea.indexOf(' ');
          int n=linea.length();
          String utente=linea.substring(0,x);
          if(utente.equalsIgnoreCase(user)) {
               String pwd=linea.substring(x+1,n);
               if(pwd.equalsIgnoreCase(pass)) return 1;}
           return 0;
          
    }//Fine accesso()      

/*METODO PER L'AGGIORNAMENTO DEL DATABASE SE INCONSISTENTE    
 -----------------------------------------------------------------------------------------------------------   */ 
 
void tryUpdate(){

  if((aggiornamento.getUPD())!=0){//se ho un DB inconsistente
     boolean DBUpdate=aggiornamento.update(database);//verifico se ho aggiornato il DB logico
     if(DBUpdate==true){//se ho aggiornato
        database.aggiornaDB();//salvo l'aggiornamento su DBFISICO
     }
     aggiornamento.checkLost();//verifico eventuali posti da non ricercare di nuovo
}


}//Fine tryUpdate
    
    
    
   /*METODI PER LA CHIUSURA DEL COLLEGAMENTO
  ---------------------------------------------------------------------------------------------------------------------------------------------------
*/    

//Usata per gestire la fine della transazione
void fineTransazione() {

     database.updateCOMMIT();//Aggiorno il numero dei COMMIT
     int n=database.readCOMMIT();//leggo quanti aggiornamenti ho fatto
     if(n==1){//se ho fatto l'aggiornamento
          database.resetCOMMIT();//riazzero la variabile
          database.aggiornaDB();//e aggiorno il DB fisico
          database.aggiornaDati();
     }
     tryUpdate();
     closeConnection();
   
}//Fine fineTransazione()


//Usata per chiudere la connessione e uccidere il thread in esecuzione
void closeConnection(){
    
    try{
       client.close();
       areaTesto.append("\nChiudo collegamento ");
    }catch(IOException ex) {;}
    this.stop();

}//fine closeConnection()

 /*GESTIONE RICHIESTE DALL'ALTRO SERVER
  ---------------------------------------------------------------------------------------------------------------------------------------------------
  */
  
  //Gestisce le richieste da parte dell'altro server di scambio di informazioni per la consistenza
  void serverRequest(){
      
      areaTesto.append("\nGestisco la transazione con un altro server");
      int c=sendMessage("OK");//Accetto la connessione dall'altro server
      if(c==0) closeConnection();
      
      String message=receiveMessage();//ricevo il messaggio dall'altro server
      
      if(message.equalsIgnoreCase("CHECK")){//richiesta di transazioneCASO 1
        				int ans=sendMessage("OK");
        				if(ans==0) closeConnection();
        				message=receiveMessage();//Ricevo messaggio sullo stato del posto e
        				checkStatus(message);//passo al controllo sullo stato del posto
        }
        
       if(message.equalsIgnoreCase("DB")){//ricevo richiesta dl file di databaseCASO 2
                                      areaTesto.append("Ricevuta richiesta di aggiornamento remoto");
                                      int ans=sendMessage("OK");//Aggiungere controllo sulla ricezione del messaggio
        			      sendDB();
        }
        
        if(message.equalsIgnoreCase("UPD")){//ricevo richiesta di aggiornamentoCASO 3
        				int ans=sendMessage("OK");
        				if(ans==0) closeConnection();
        				acceptUPD();
        }
			 
        
       if ((!(message.equalsIgnoreCase("DB"))) &&(!(message.equalsIgnoreCase("CHECK")))&&(!(message.equalsIgnoreCase("UPD")))) closeConnection();
  
  }//Fine serverRequest
  
  
  
  //Gestisce l'update con l'altro server
  void acceptUPD(){
    
    boolean finished=false;
    String message,settore,fila,posto,stato,nome;
    int d,f,l,ans;
    
    while(!finished){
    
       message=receiveMessage();//ricevo la richiesta per un posto specifico
       if((message==null)||(message.equalsIgnoreCase("TERM"))) finished=true;
       else{//e la elaboro
            d=message.indexOf('.');
            f=message.length();
            l=message.indexOf('-');
            settore=message.substring(0,d);
            fila=message.substring(d+1,l);
            posto=message.substring(l+1,f);
            stato=database.checkPlace(settore,fila,posto);
            if(stato.equals("F")){
               nome=database.getName(settore,fila,posto);
               message=stato+"."+nome;
            }
            else message=stato;
            ans=sendMessage(message);//quindi spedisco la risposta
            if(ans==0)finished=true;
       }
    
  }
  
  closeConnection();
  
}// Fine acceptUPD
  
  
  
  //Usata per spedire il DB all'altServer
  void sendDB(){
  
   Vector DBcopy=new Vector();
   DBcopy=database.dumpDB();
   int dim=DBcopy.size();
   for(int i=0;i<dim;++i){
        String s=(String) DBcopy.elementAt(i);
        int ans=sendMessage(s);
    }
   int ans=sendMessage("DATA");
   sendDataFile();
   closeConnection();
  
  }//Fine sendDB()
 
 
 //Spedizione dei dati sui posti
  void sendDataFile(){
      
      int ans;
      Vector dataFileCopy=database.dumpDataFile();
      int dim=dataFileCopy.size();
      if(dim==0) ans=sendMessage("TERM");
      else{
         for(int i=0;i<dim;++i){
            String s=(String)dataFileCopy.elementAt(i);
            ans=sendMessage(s);
         }
         ans=sendMessage("TERM");
      }
      
  }//Fine sendDataFile
  
  //Usata per verificare lo stato di un posto
  void checkStatus(String message){
  
       if(message==null) closeConnection();//Controllo sul messaggio
       
       int d=message.indexOf('.');
       int f=message.length();
       int l=message.indexOf('-');
       String settore=message.substring(0,d);
       String fila=message.substring(d+1,l);
       String posto=message.substring(l+1,f);
       String status=database.readAndUpdateDB(settore,fila,posto);//leggo ed eventualmente aggiorno il posto 
       try{											       //richiesto dll'altro server
       if(status.equalsIgnoreCase("OCC")) {
           chatForPriority(settore,fila,posto);//se  occupato devo gestire la priorit
       }
       
       if(status.equalsIgnoreCase("NO")) {
                   sendMessage(status);//se  pieno gli dico che  pieno.......
                   closeConnection();//e per me  finita la transazione
        }
       
        if(status.equalsIgnoreCase("OK")) {
                 sendMessage(status);//se  libero glielo faccio sapere
                 areaTesto.append("\nComunico che  libero il posto all'altro server");
                
                 message=receiveMessage();//e mi metto in attesa di una rispostaɤ
                 
                 areaTesto.append("\nAttendo esito transazione");
                 
                 
                 if(message.equalsIgnoreCase("ABT")){//transazione abortita
                        database.setTicket(settore,fila,posto,"E");   
                        closeConnection();
                     } 
                     
                 if(message.startsWith("SET")){//Devo settare il posto a F
                     areaTesto.append("\nConferma ricevuta");
                     d=message.indexOf('.');
                     int j=message.length();
                     String nome=message.substring(d+1,j);//ricavo i dati del titolare
                      
                     database.setTicket(settore,fila,posto,"F");   
                     database.setName(settore,fila,posto,nome);
                     int ans=sendMessage("OK");
                     message=receiveMessage();//attendo risposta sulla conferma al client
                     if(message.equalsIgnoreCase("TERM")) fineTransazione(); //transazione conclusa con successo
                     if(message.equalsIgnoreCase("ABT")){//transazione abortita
                        database.setTicket(settore,fila,posto,"E");   
                        closeConnection();
                     } 
                 }
                 
       }
        
        
     }catch(NullPointerException npe) {
                     database.setTicket(settore,fila,posto,"E");   
                     closeConnection();
                  }                       
  
  }//Fine checkStatus()
  
  //Usata per decidere chi ha diritto al posto
  void chatForPriority(String settore,String fila,String posto){
  
      int n;
      boolean mine=false;
      String data="";
      
      int ans=sendMessage("OCC");//Segnalo che il posto  occupato e
      if(ans==0) closeConnection();
      
      String message=receiveMessage();//ricevo la risposta del server in forma di hh:mm.ss
      if(message==null) closeConnection();
      
      int d=message.indexOf(':');
      data=message.substring(0,d-1);
      String tempo=message.substring(d+1,message.length());
      
      GregorianCalendar myDataPrenotaz=database.getDataPrenotaz(settore,fila,posto);//recupero la data della mia prenotaz
      
      n=message.length();//divido il messaggio ricevuto in ora minuti e secondi
      int i=message.indexOf(':');
      String h=message.substring(0,i);
      int x=message.indexOf('.');
      String m=message.substring(i+1,x);
      String s=message.substring(x+1,n);
      
      int ora=Integer.parseInt(h);//ricavo i dati della prenotazione remota
      int minuti=Integer.parseInt(m);
      int secondi=Integer.parseInt(s);
      
      int myHour=myDataPrenotaz.get(Calendar.HOUR);//ricavo i dati della prenotazione locale
      int myMinute=myDataPrenotaz.get(Calendar.MINUTE);
      int mySecond=myDataPrenotaz.get(Calendar.SECOND);
      
      mine=confrontaTempi(myHour,myMinute,mySecond,ora,minuti,secondi);
      
      if(mine==true){//il posto  mio
         ans=sendMessage("NO");//lo comunico
         closeConnection();//e chiudo il collegamento con il client.
      }
      if(mine==false) { //il posto  dell'altro server
          ans=sendMessage("OK");//lo comunico
          message=receiveMessage();//e attendo risposta
          
          if(message.startsWith("SET")){//se  confermato il pagamento
                d=message.indexOf('.');
                int j=message.length();
                String nome=message.substring(d+1,i);//ricavo i dati del titolare

                areaTesto.append("Ricevuta dall'altro server conferma del posto");
                database.setTicket(settore,fila,posto,"F");//aggiorno il mio DB
                database.setName(settore,fila,posto,nome);
                ans=sendMessage("OK");//e comunico all'altro server l'aggiornamento del DB
                fineTransazione();//e quindi chiudo la transazione
             }
             
            if((message.equalsIgnoreCase("ABT"))||(message==null)){//Devo abortire la transazione
                     database.setTicket(settore,fila,posto,"E");   
                     closeConnection();
             }
         
      }
  
  }//Fine chatForPriority()
 
//Usata per decidere la controversia 
boolean confrontaTempi(int myHour,int myMinute,int mySecond,int ora,int minuti, int secondi){
       
       boolean mine=true;
       
       if(myHour<ora) return true;
       if(myHour>ora) return false;
       if(myHour==ora){
              if(myMinute<minuti) return true;
              if(myMinute>minuti) return false;
              if(myMinute==minuti){
                  if(mySecond<secondi) return true;
                  if(mySecond>secondi) return false;
                  if(mySecond==secondi){
                       Random r=new Random(123456789);
                       int myRandom=r.nextInt();
                       int yourRandom=r.nextInt();
                       if(myRandom>yourRandom) return true;
                       else return false;
                  }
              }
        }
        
   return false;           
              

}//Fine confrontaTempi()

/*
--------------------------------------------------------------------------------------------------------------------------------------------------
METODI DI SERVIZIO PER LA RICEZIONE E LA SPEDIZIONE DEI MESSAGGI AL CLIENT*/

//Usata per ricevere messaggi       
  String receiveMessage() {     
       
      
            try{
              
              inLine=inStream.readLine();
              

             }catch(IOException ex) {return null;}   
               
                return inLine;
            }
            
            
//Usata per spedire messaggi            
     int sendMessage(String message) {
     
         try{
       
        for(int i=0;i<message.length();++i) 
           outStream.write(message.charAt(i));
           outStream.write(13);
           outStream.write(10);
           outStream.flush();
           
          }catch (IOException ex) {//Se c' un'eccezione rispedisco e riprovo
                    try{
       
        		for(int i=0;i<message.length();++i) 
          			 outStream.write(message.charAt(i));
         			 outStream.write(13);
           			 outStream.write(10);
          			 outStream.flush();
           
                      }catch (IOException ioex) {//se fallisco di nuovo dichiaro fallimento
                              return 0;}
          }  
          return 1; 
     
     
     }//Fine sendMessage()
     

    
    
    }//Fine ServerThread
     
 
     
     
  
                
                
 
             
                 
                 
           
     
    