
import java.lang.System;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.String;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.ProgressMonitor;
import java.net.*;
import java.util.*;
import java.util.GregorianCalendar;
import java.util.Random;

public  class serverInit {

          
            // String server2="localhost";
            //int server2Port=1235;
            BufferedReader inStream;
            DataOutputStream outStream;
            String inLine;
            Socket  connection=null;
            String server=null;
            String server2=null;
            String bankServer=null;
            int serverPort,server2Port,bankServerPort;
            String[] defaultServer={"localhost","1234","localhost","1235","localhost","1236"};
            String[] defaultPref={"INFO: 100000 200000 200000 300000 550000 1000000 250000 250000","A: 5","B: 5","C: 5","D: 5","E: 5","F: 5","G: 5","H: 5"};
   
  //Inizializzazione del server
  void initServer(){
       
       boolean end=false;
       Vector paramServer=null;
       try{
          FileReader inFile=new FileReader("serverPref.txt");
          LineNumberReader inLines= new LineNumberReader(inFile);
          String testo=null;
          paramServer=new Vector();
          for(int i=0;i<6;++i){
             testo=inLines.readLine();
             paramServer.addElement(testo);
          }
      }catch (IOException ex) {
                           ripristinaServerPref();
                           initServer();
                           end=true;
                           }
    if(!end){//se ho gi eseguito la init server, non devo rifarla!!!!!!!!!!!!!
                     
       server2=(String)paramServer.elementAt(2);
       server=(String) paramServer.elementAt(0);
       bankServer=(String) paramServer.elementAt(4);
       serverPort=Integer.valueOf((String)paramServer.elementAt(1)).intValue();
       server2Port=Integer.valueOf((String)paramServer.elementAt(3)).intValue();     
       bankServerPort=Integer.valueOf((String)paramServer.elementAt(5)).intValue();   
       boolean recover=false;
       
       //Inizializzazione del server e collegamento con l'altro server
        try{
              connection=new Socket(server2,server2Port);
        }catch(UnknownHostException uhe) {//se c' un errore
        
           try{//riprovo una seconda volta
                 connection=new Socket(server2,server2Port); 
               }catch(UnknownHostException uhe1) {//non c' nessun server
                       recover=true;   
                       newDB();
                           }
               catch(IOException ie1) {
                       recover=true;
                       newDB();
                                                      }
                                
           }
           
         catch(IOException ex) {//se  un server sconosciuto
         
           try{//riprovo una seconda volta
                 connection=new Socket(server2,server2Port); 
               }catch(UnknownHostException uhe2) {//non c' nessun server
                       recover=true;   
                       newDB();
                          		 }
               catch(IOException ie2) {
                        recover=true;
                        newDB();
                                                      }
                                                            
           }
           
    if(!recover) {//Se non  la prima esecuzione del server     
      try{//creazione dei flussi
           outStream=new DataOutputStream(connection.getOutputStream());
           inStream=new BufferedReader(new InputStreamReader(connection.getInputStream()));
      }catch(IOException ex) {
           newDB();//Come se non ci fosse l'altro server
       }
          getDBFile();//ricevo il file di Db dall'altro server
     
           try{
               connection.close();//e chiudo la connessione
           }catch(IOException ex) {System.out.println("Errore chiudendo la connessione");}
                 
                 
    }
    
  } 
  
}//Fine initServer()


  //Per ripristinare il default in caso di errore: ricrea il file di prefernze utilizzando i parametri di default
   void ripristinaServerPref() {
       
       try{
         FileOutputStream serverFile=new FileOutputStream("serverPref.txt");
         for(int i=0;i<6;++i) {
              String s=defaultServer[i]+"\n";
              for(int k=0;k<s.length();++k) {
                  serverFile.write(s.charAt(k));
              }
         }
         serverFile.close();
       }catch (IOException ex) {;//Se c' un errore anche ripristinando?????
                            } 
         
  }//Fine ripristinaServerPref


  //Per ripristinare il default in caso di errore: ricrea il file di prefernze utilizzando i parametri di default
   void ripristinaPref() {
       
       try{
         FileOutputStream prefFile=new FileOutputStream("preferences.txt");
         for(int i=0;i<9;++i) {
              String s=defaultPref[i]+"\n";
              for(int k=0;k<s.length();++k) {
                  prefFile.write(s.charAt(k));
              }
         }
         prefFile.close();
       }catch (IOException ex) {;//Se c' un errore anche ripristinando?????
                            } 
         
  }//Fine ripristinaPref

 
   String getServer2(){
       return server2;
   }
   
   int getServer2Port(){
        return server2Port;
    }
    
    String getServer() {
      return server;
    }
    
    int getPort(){
       return serverPort;
     }
    
      String getBankServer(){
       return bankServer;
   }
   
   int getBankServerPort(){
        return bankServerPort;
    }
   
   //Usata per ricevere il file di database
   void getDBFile(){
       
       int ans=sendMessage("AS");//Richiedo l'accesso come server
       
       if(ans==1){//se il messaggio  stato spedito
       String message=receiveMessage();//attendo conferma
       
       if(message.equalsIgnoreCase("OK")){
            ans=sendMessage("DB");//richiedo il file di DB
            if(ans==1){
              message=receiveMessage();
              if(message.equalsIgnoreCase("OK")){
                receiveDB();
             }
              else newDB();
           }
           else newDB();
         }
         else newDB();
      }
      else newDB();
      
   }//Fine getDBFile()
  
  //Riceve il file dall'altServer
  void receiveDB() {
     
     boolean finished=false;
     FileOutputStream dbFile;
     try{
         dbFile=new FileOutputStream("database.txt");
         while(!finished){
             String message=receiveMessage();
             
             if(message==null){
               newDB();
               break;
             }
             if(message.equalsIgnoreCase("DATA")) {//Messaggio di partenza file Dati
                dbFile.close();
                receiveDataFile(); 
                break;
             }
             if(message.equalsIgnoreCase("TERM")) {//Messaggio di chiusura del collegamento
                   dbFile.close();//da chiudere anche il collegamento
                   finished=true;
                }
             else{
                save(message,dbFile);//Salvo la stringa ricevuta
              }
     }    
       
      }catch(IOException ex){newDB();}
  
  
  }//Fine receiveDB() 
  
  //Riceve il file dall'altServer
  void receiveDataFile() {
     
     boolean finished=false;
     FileOutputStream dataFile=null;
     try{
         dataFile=new FileOutputStream("dati.txt");
         while(!finished){
             String message=receiveMessage();
             
             if(message==null){
               dataFile.close();
               break;
             }
             if(message.equalsIgnoreCase("TERM")) {//Messaggio di chiusura del collegamento
                   dataFile.close();//da chiudere anche il collegamento
                   finished=true;
                }
             else{
                save(message,dataFile);//Salvo la stringa ricevuta
              }
     }    
       
      }catch(IOException ex){
           try{
              dataFile.close();
           }catch(IOException ioex){;}
      }
  
  
  }//Fine receiveDataFile() 

  
  
  //Usata per creare ex-novo un DB se sono l'unico server attivo
  void newDB(){
  
        boolean end=false;
        Vector sector=new Vector();
        try{
       
          FileReader inFile=new FileReader("preferences.txt");
          LineNumberReader inLines= new LineNumberReader(inFile);
          String testo;
          while ((testo=inLines.readLine()) != null) {
                  sector.addElement(testo);
              
          }
      }catch (IOException ex) {
                           ripristinaPref();
                           newDB();
                           end=true;
                           }
  
     
      if(!end) writeDB(sector);       
   }//Fine newDB()
   
  //Usato per scrivere ex-novo un DB se si  l'unico server
   void writeDB(Vector sector) {
   
      FileOutputStream dbFile=null;
      int dim=sector.size();
       try{
         dbFile=new FileOutputStream("database.txt");
     }catch(IOException ex){System.out.println("Errore nella scrittura del database");}
  
      if(dim==9){//la lettura del file di preferenze  corretta
        for(int i=0;i<dim;++i){//Per ogni elemento del vettore
              String s=(String) sector.elementAt(i);
              if(s.startsWith("INFO")) save(s,dbFile);
              else creaSettore(s,dbFile);
        
       }
       
    }
      
      else{//la lettura del file di preferenze non  corretta, devo ripristinare a default
      }
  
   try{
   dbFile.close();  
 
 } catch(IOException ex) {System.out.println("Errore nelle chiusura del flusso");}
  
 }//Fine writeDB();  
  
 //Usato per creare le linee da salvare sul file di database 
 void creaSettore(String text,FileOutputStream dbFile) {
 
      String f=null;
      String p=null;
      
      int j =text.indexOf(':');
      String settore=text.substring(0,j);
      String file=text.substring(j+2,text.length());
      int nfile=Integer.parseInt(file);
      int nposti=nfile*10;
      String posti=Integer.toString(nposti);
      String head="SETTORE "+settore+" POSTI "+posti+" FILE "+file;
      save(head,dbFile);
      for(int i=1;i<=nfile;++i){//Per ogni fila
           f=Integer.toString(i);
          for(int k=1;k<11;++k) {//per ogni posto
              p=Integer.toString(k);
              String s=f+"-"+p+" E";
              save(s,dbFile);
          }
     }
 }//Fine creaSettore
  
  //Salva le linee sul file creato            
  void save(String text, FileOutputStream dbFile) {
  
     text=text+"\n";
     try{
     
       for(int k=0;k<text.length();++k) {
                  dbFile.write(text.charAt(k));
       }
       
   }catch(IOException ex) {System.out.println("Errore nella scrittura del database");}        
  
  }//Fine save();       

/*
--------------------------------------------------------------------------------------------------------------------------------------------------
METODI DI SERVIZIO PER LA RICEZIONE E LA SPEDIZIONE DEI MESSAGGI AL SERVER*/

//Usata per ricevere messaggi       
  String receiveMessage() {     
       
      
            try{
              
              inLine=inStream.readLine();
              

             }catch(IOException ex) {System.out.println("Errore");}   
             catch(NullPointerException npe) {/*Crash del collegamento!!!!*/}
                return inLine;
            }
            
            
//Usata per spedire messaggi            
 int sendMessage(String message) {
     
         try{
       
        for(int i=0;i<message.length();++i) 
           outStream.write(message.charAt(i));
           outStream.write(13);
           outStream.write(10);
           outStream.flush();
           
          }catch (IOException ex) {//Se c' un'eccezione rispedisco e riprovo
                    try{
       
        		for(int i=0;i<message.length();++i) 
          			 outStream.write(message.charAt(i));
         			 outStream.write(13);
           			 outStream.write(10);
          			 outStream.flush();
           
                      }catch (IOException ioex) {//se fallisco di nuovo dichiaro fallimento
                              return 0;}
          }  
          return 1; 
     
     
     }//FIne sendMessage()
     

    
    
    }//Fine serverInit
     
 
     
     
  
                
                
 
             
                 
                 
           
     
    